NmBookMorph subclass: #NmProjectBookMorph
	instanceVariableNames: 'loader mapEntryMorph numberOfProjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Project'!

!NmProjectBookMorph methodsFor: 'initialize-release' stamp: 'mu 7/3/2005 23:11'!
existingOn: aMapEntryMorph
	| existing |
	existing _ ActiveWorld submorphs
				select: [:each | (each isKindOf: self class)
						and: [each mapEntryMorph = self mapEntryMorph]].
	^existing! !

!NmProjectBookMorph methodsFor: 'initialize-release' stamp: 'mu 7/28/2005 01:55'!
initItemsFrom: start to: end 
	^ self pageMorph
		initSubmorphsFrom: start
		to: end
		matches: self matchString
		matchOptions: self matchOptions
		sortOptions: self sortOptions! !

!NmProjectBookMorph methodsFor: 'initialize-release' stamp: 'mu 7/25/2005 14:46'!
initialize
	super initialize.
	
	self addMorphBack: self buildActionButtonPanel.
	self addMorphBack: self buildFindPanel.
	self addMorphBack: NmProjectPageMorph new.
	self addMorphBack: self buildInfoBar
	! !

!NmProjectBookMorph methodsFor: 'initialize-release' stamp: 'mu 7/25/2005 15:13'!
initLayout
	self changeTableLayout; listDirection: #topToBottom; wrapCentering: #center.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self layoutInset: 3 @ 3.
	self cellInset: 3.
	! !

!NmProjectBookMorph methodsFor: 'initialize-release' stamp: 'mu 7/16/2005 21:04'!
openInHand
	| existing |
	existing _ self existingOn: self mapEntryMorph.
	existing isEmpty
		ifTrue: [super openInHand.
			self openPage]
		ifFalse: [ActiveWorld addMorphFront: existing first lastPage]! !


!NmProjectBookMorph methodsFor: 'testing' stamp: 'mu 7/1/2005 20:33'!
isWarpable
	^false! !


!NmProjectBookMorph methodsFor: 'accessing' stamp: 'mu 7/1/2005 20:25'!
loader
	^loader! !

!NmProjectBookMorph methodsFor: 'accessing' stamp: 'mu 7/1/2005 20:25'!
loader: aProjectLoader
	loader _ aProjectLoader! !

!NmProjectBookMorph methodsFor: 'accessing' stamp: 'mu 7/1/2005 20:25'!
mapEntryMorph
	^mapEntryMorph! !

!NmProjectBookMorph methodsFor: 'accessing' stamp: 'mu 7/1/2005 20:25'!
mapEntryMorph: aMapEntryMorph
	mapEntryMorph _ aMapEntryMorph! !

!NmProjectBookMorph methodsFor: 'accessing' stamp: 'mu 7/28/2005 01:45'!
numberOfItems
	^self numberOfProjects
		! !

!NmProjectBookMorph methodsFor: 'accessing' stamp: 'mu 7/26/2005 01:53'!
numberOfProjects
	numberOfProjects
		ifNil: [numberOfProjects _ self loader getNumberOfProjectsMatches: self matchString matchOptions: ''].
	^ numberOfProjects! !

!NmProjectBookMorph methodsFor: 'accessing' stamp: 'mu 7/1/2005 19:48'!
pageMorph
	^self findA: NmProjectPageMorph! !


!NmProjectBookMorph methodsFor: 'actions' stamp: 'mu 7/25/2005 15:16'!
reload
	numberOfProjects _ nil.
	self openPage.! !


!NmProjectBookMorph methodsFor: 'stepping' stamp: 'mu 7/15/2005 15:32'!
step
	self mapEntryMorph ifNil: [^self].
	self setNameTo: self mapEntryMorph mapEntry destination , '''s Projects'.
	self window ifNotNilDo: [:w | w setLabel: self knownName].
	! !

!NmProjectBookMorph methodsFor: 'stepping' stamp: 'mu 7/1/2005 20:33'!
stepTime
	^2000! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmProjectBookMorph class
	instanceVariableNames: ''!

!NmProjectBookMorph class methodsFor: 'interface opening' stamp: 'mu 7/15/2005 00:17'!
on: aMapEntryMorph
	^self new 
		mapEntryMorph: aMapEntryMorph;
		loader: (NmProjectLoader on: aMapEntryMorph mapEntry)! !


SimpleButtonMorph subclass: #NmProjectCellMorph
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Project'!

!NmProjectCellMorph methodsFor: 'constants' stamp: 'mu 6/21/2005 16:51'!
defaultColor
	^ (Color r: 1.0 g: 0.79 b: 0.485)! !


!NmProjectCellMorph methodsFor: 'menu-actions' stamp: 'mu 7/6/2005 21:09'!
diveProject: projectName 
	self inform: 'Not implemented yet. Please wait for SeeThroughTalk'! !

!NmProjectCellMorph methodsFor: 'menu-actions' stamp: 'mu 7/13/2005 00:00'!
loadProject: projectName 
	self loader enterNewProject: projectName ! !

!NmProjectCellMorph methodsFor: 'menu-actions' stamp: 'mu 7/15/2005 01:46'!
openProject: projectName 
	| window view |
	view _ self loader openProjectView: projectName.
	window _ view ownerThatIsA: SystemWindow.
	window
		ifNil: [window _ view openInWindow.
			"window setLabel: projectName."
			window model: view project.
			window update: #relabel.
			window setProperty: #projectWindow toValue: true]
		ifNotNil: [ActiveWorld addMorphFront: window]! !


!NmProjectCellMorph methodsFor: 'accessing' stamp: 'mu 7/14/2005 22:08'!
formExtent
	self imageMorph ifNil: [^0@0].
	^self imageMorph extent! !

!NmProjectCellMorph methodsFor: 'accessing' stamp: 'mu 7/14/2005 22:02'!
imageMorph
	^self findA: ImageMorph! !

!NmProjectCellMorph methodsFor: 'accessing' stamp: 'mu 6/21/2005 15:09'!
label
	^label! !

!NmProjectCellMorph methodsFor: 'accessing' stamp: 'mu 6/21/2005 15:10'!
label: aString
	label _ aString! !

!NmProjectCellMorph methodsFor: 'accessing' stamp: 'mu 6/30/2005 19:48'!
loader
	| parent |
	parent _ (self ownerThatIsA: NmProjectPageMorph) ifNil: [^nil].
	^parent loader! !

!NmProjectCellMorph methodsFor: 'accessing' stamp: 'mu 6/21/2005 16:30'!
target
	^self loader ifNil: [super target] ifNotNil: [self loader]! !


!NmProjectCellMorph methodsFor: 'initialize-release' stamp: 'mu 6/21/2005 16:55'!
initialize
	super initialize.
	self initLayout.
	
	self color: self defaultColor.
	self borderColor:  self color darker.
	
	! !

!NmProjectCellMorph methodsFor: 'initialize-release' stamp: 'mu 6/21/2005 14:48'!
initLayout
	
	self changeTableLayout.
	self listDirection: #topToBottom.
	self wrapCentering: #center.
	self listCentering: #center.
	self layoutInset: 5@5.
	self cellInset: 3.
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.

	self useRoundedCorners! !

!NmProjectCellMorph methodsFor: 'initialize-release' stamp: 'mu 7/13/2005 00:00'!
initTarget
	
	self actionSelector: #enterNewProject:.
	self target: self target.
	self arguments: {self label}! !

!NmProjectCellMorph methodsFor: 'initialize-release' stamp: 'mu 6/21/2005 16:59'!
setForm: form label: labelString
	self removeAllMorphs.
	self addMorphFront: form asMorph.
	self addMorphBack: labelString asMorph.
	
	self label: labelString asString.
	! !


!NmProjectCellMorph methodsFor: 'testing' stamp: 'mu 7/1/2005 20:33'!
isWarpable
	^false! !


!NmProjectCellMorph methodsFor: 'event handling' stamp: 'mu 7/6/2005 21:01'!
mouseDown: evt 
	evt yellowButtonPressed ifTrue: [^self popupYellowButtonMenu: evt].
	super mouseDown: evt ! !


!NmProjectCellMorph methodsFor: 'menu' stamp: 'mu 7/14/2005 23:15'!
popupYellowButtonMenu: evt
	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu add: 'load' translated selector: #loadProject: argument: self label.
	menu add: 'open' translated selector: #openProject: argument: self label.
	menu addLine.
	menu add: 'dive' translated selector: #diveProject: argument: self label.
	menu popUpInWorld! !


!NmProjectCellMorph methodsFor: 'geometry' stamp: 'mu 7/14/2005 22:03'!
scaledToSize: anExtent
	self imageMorph ifNotNilDo: [:im | im scaledToSize: anExtent].! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmProjectCellMorph class
	instanceVariableNames: ''!

!NmProjectCellMorph class methodsFor: 'instance creation' stamp: 'mu 6/21/2005 16:27'!
form: form label: labelString
	^self new setForm: form label: labelString! !


Object subclass: #NmProjectLoader
	instanceVariableNames: 'worldMapEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Project'!

!NmProjectLoader methodsFor: 'accessing' stamp: 'mu 7/7/2005 01:11'!
connector
	| ent |
	ent _ self worldMapEntry.
	^ [NmRemoteConnector connect: ent ip port: ent port asInteger]
		on: RmtNetworkError
		do: [:ex | 
			NmShortMessageMorph contents: ex messageText at: ActiveWorld center.
			ex return: nil]! !

!NmProjectLoader methodsFor: 'accessing' stamp: 'mu 7/26/2005 01:35'!
connectorDo: aBlock 
	^ self connectorDo: aBlock ifErrorReturn: nil! !

!NmProjectLoader methodsFor: 'accessing' stamp: 'mu 7/26/2005 01:58'!
connectorDo: aBlock ifErrorReturn: returnObj 
	| con |
	con _ self connector.
	con isNil
		ifTrue: [^ returnObj].
	^ [aBlock value: con]
		on: RmtNetworkError
		do: [:ex | 
			NmShortMessageMorph contents: ex messageText at: ActiveWorld center.
			ex return: returnObj]! !

!NmProjectLoader methodsFor: 'accessing' stamp: 'mu 7/6/2005 21:21'!
worldMapEntry
	^worldMapEntry! !

!NmProjectLoader methodsFor: 'accessing' stamp: 'mu 7/6/2005 21:21'!
worldMapEntry: aNmWorldMapEntry
	worldMapEntry _ aNmWorldMapEntry! !


!NmProjectLoader methodsFor: 'actions' stamp: 'mu 6/21/2005 01:09'!
detailedInfoTextFor: projectName 
	| details detailText |
	details _ self getProjectDetails: projectName.
	detailText _ String
				streamContents: [:str | details
						keysAndValuesDo: [:k :v | v notEmpty
								ifTrue: [str nextPutAll: (k copyFrom: 'project' size + 1 to: k size)
											, ':';
										 tab;
										 nextPutAll: v;
										 cr]]].
	^ detailText! !

!NmProjectLoader methodsFor: 'actions' stamp: 'mu 7/14/2005 23:27'!
enterNewProject: projectName 
	| proj |
	proj _ self getAndTrimProject: projectName.
	proj enter! !

!NmProjectLoader methodsFor: 'actions' stamp: 'mu 6/21/2005 00:34'!
getProjectDetails: projectName 
	| data stream datails |
	data _ self getProjectInfo: projectName.
	stream _ RWBinaryOrTextStream with: data.
	datails _ NmBaseUtil loadDataFrom: stream .
	^datails! !

!NmProjectLoader methodsFor: 'actions' stamp: 'mu 6/21/2005 00:20'!
getProjectThumbnailForm: projectName
	| data form |
	data _ self getProjectThumbnail: projectName.
	form _ ImageReadWriter formFromStream: (RWBinaryOrTextStream with: data).
	^form! !

!NmProjectLoader methodsFor: 'actions' stamp: 'mu 7/14/2005 23:59'!
openProjectView: projectName 
	| proj projView |
	proj _ self getAndTrimProject: projectName.
	projView _ ActiveWorld allMorphs
				detect: [:each | (each isKindOf: ProjectViewMorph)
						and: [each project = proj]]
				ifNone: [ProjectViewMorph on: proj].
	projView extent: ActiveWorld extent // 4.
	^ projView! !


!NmProjectLoader methodsFor: 'private' stamp: 'mu 7/15/2005 00:12'!
getAndTrimProject: projectName 
	| proj |
	proj _ self getProject: projectName.
	proj renameTo: (self longNameFrom: projectName).
	self trimDuplicates: proj.
	^ proj! !

!NmProjectLoader methodsFor: 'private' stamp: 'mu 7/15/2005 00:45'!
longNameFrom: aProjectShortName 
	self worldMapEntry
		ifNil: [^ aProjectShortName].
	^ aProjectShortName , '-' , self worldMapEntry destination! !

!NmProjectLoader methodsFor: 'private' stamp: 'mu 7/15/2005 00:14'!
trimDuplicates: proj
	| duplicates |
	duplicates _ Project allProjects
				select: [:each | each name = proj name
						and: [each lastSavedAtSeconds = proj lastSavedAtSeconds]].
	duplicates remove: proj ifAbsent:[].
	duplicates
		ifNotEmpty: [proj inheritAdjustmentFrom: duplicates first.
			Project removeAll: duplicates.
			duplicates
				do: [:p | ChangeSorter removeChangeSet: p changeSet]].
! !


!NmProjectLoader methodsFor: 'actions-basic' stamp: 'mu 7/26/2005 01:37'!
getNumberOfProjectsMatches: matchString matchOptions: matchOptionString 
	^ self
		connectorDo: [:c | c callGetNumberOfProjectsMatches: matchString matchOptions: matchOptionString]
		ifErrorReturn: 0! !

!NmProjectLoader methodsFor: 'actions-basic' stamp: 'mu 7/7/2005 01:14'!
getProjectInfo: projectName 
	^ [self
		connectorDo: [:c | c callGetProjectInfo: projectName]]
		on: FileDoesNotExistException
		do: [:ex | ex return: Dictionary new]! !

!NmProjectLoader methodsFor: 'actions-basic' stamp: 'mu 7/26/2005 01:35'!
getProjectNamesFrom: start to: end matches: matchString matchOptions: matchOptionString sortOptions: sortOptionString 
	^ [self
		connectorDo: [:c | c
				callGetProjectNamesFrom: start
				to: end
				matches: matchString
				matchOptions: matchOptionString
				sortOptions: sortOptionString] ifErrorReturn: #()]
		on: Error
		do: [:ex | ex messageText = 'key not found'
				ifTrue: [NmProjectSortFailed sortOptionString: sortOptionString]
				ifFalse: [ex pass]]! !

!NmProjectLoader methodsFor: 'actions-basic' stamp: 'mu 7/7/2005 01:16'!
getProjectThumbnail: projectName 
	^ [self
		connectorDo: [:c | c callGetProjectThumbnail: projectName]]
		on: FileDoesNotExistException
		do: [:ex | ex
				return: (Form extent: Display extent // 8 depth: Display depth)]! !

!NmProjectLoader methodsFor: 'actions-basic' stamp: 'mu 7/7/2005 01:16'!
getProject: projectName 
	^ self
		connectorDo: [:c | c callGetProject: projectName]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmProjectLoader class
	instanceVariableNames: ''!

!NmProjectLoader class methodsFor: 'instance creation' stamp: 'mu 7/6/2005 21:24'!
on: aNmWorldMapEntry
	"NmProjectLoader on: NmWorldMap localEntry"
	^self new worldMapEntry: aNmWorldMapEntry! !


RectangleMorph subclass: #NmProjectPageMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Project'!

!NmProjectPageMorph methodsFor: 'accessing' stamp: 'mu 7/14/2005 22:27'!
cellMorphs
	^self submorphs select: [:each | each isKindOf: NmProjectCellMorph]! !

!NmProjectPageMorph methodsFor: 'accessing' stamp: 'mu 7/1/2005 20:35'!
loader
	| parent |
	parent _ (self ownerThatIsA: NmProjectBookMorph) ifNil: [^nil].
	^parent loader! !


!NmProjectPageMorph methodsFor: 'constants' stamp: 'mu 6/21/2005 15:13'!
defaultColor
	^  (TranslucentColor r: 0.161 g: 0.839 b: 0.742 alpha: 0.298)! !


!NmProjectPageMorph methodsFor: 'user interface' stamp: 'mu 6/21/2005 17:06'!
defaultLabelForInspector
	^self knownName! !


!NmProjectPageMorph methodsFor: 'layout' stamp: 'mu 7/15/2005 15:13'!
fixExtent: maxExtent
	| recommendedExtent max |
	self cellMorphs isEmpty
		ifTrue: [^ self].
	max _ (self cellMorphs collect: [:each | each formExtent]) max.
	recommendedExtent _ max min: maxExtent.
	self cellMorphs
		do: [:each | each scaledToSize: recommendedExtent].
	! !

!NmProjectPageMorph methodsFor: 'layout' stamp: 'mu 7/15/2005 15:33'!
layoutChanged
	super layoutChanged.
	self fixExtent: (ActiveWorld extent // 6).
	! !


!NmProjectPageMorph methodsFor: 'initialize-release' stamp: 'mu 6/21/2005 16:50'!
initialize
	super initialize.
	self initLayout.
	
	self setNameTo: 'Projects'.
	self borderColor: self color darker.
	! !

!NmProjectPageMorph methodsFor: 'initialize-release' stamp: 'mu 6/21/2005 16:49'!
initLayout
	self changeTableLayout;
		listDirection: #leftToRight;
		wrapCentering: #topLeft;
		wrapDirection: #topToBottom;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	self layoutInset: 5@5.
	self cellInset: 3.
	
	self useRoundedCorners
		! !

!NmProjectPageMorph methodsFor: 'initialize-release' stamp: 'mu 7/16/2005 21:00'!
initSubmorphsFrom: start to: end matches: matchString matchOptions: matchOptionString sortOptions: sortOptionString
	| projNames cells |
	projNames _ [self loader getProjectNamesFrom: start to: end matches: matchString matchOptions: matchOptionString sortOptions: sortOptionString] on: NmProjectSortFailed do: [:ex | self inform: ex messageText, ' sort failed' translated. ^self].
	cells _ OrderedCollection new.
	projNames
		do: [:each | 
			| form cellMorph | 
			form _ self loader getProjectThumbnailForm: each.
			cellMorph _ NmProjectCellMorph form: form label: each.
			cellMorph setBalloonText: (self loader detailedInfoTextFor: each).
			cells add: cellMorph].
	self removeAllMorphs.
	cells
		do: [:each | 
			self addMorphBack: each.
			each initTarget].
	cells size > 0 ifTrue: [self extent: 10000 @ 10000].
	self layoutChanged! !


!NmProjectPageMorph methodsFor: 'testing' stamp: 'mu 6/21/2005 16:01'!
isWarpable
	^false! !


SimpleButtonDelayedMenuMorph subclass: #NmProjectPublishButtonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Project'!

!NmProjectPublishButtonMorph methodsFor: 'private' stamp: 'mu 6/17/2005 17:21'!
canPublish
	self world paintBoxOrNil
		ifNotNil: [self confirm: 'You seem to be painting a sketch.
Do you continue and publish the project with the paint tool?' translated].
	^ true! !

!NmProjectPublishButtonMorph methodsFor: 'private' stamp: 'mu 6/18/2005 22:41'!
computeColor
	^ self project isNetMorphPublished
				ifTrue: [self defaultPublishedColor]
				ifFalse: [self defaultColor]! !


!NmProjectPublishButtonMorph methodsFor: 'constants' stamp: 'mu 6/18/2005 22:44'!
defaultColor
	^ (Color r: 1.0 g: 0.79 b: 0.485)! !

!NmProjectPublishButtonMorph methodsFor: 'constants' stamp: 'mu 6/18/2005 22:39'!
defaultLabel
	^'Publish!!'! !

!NmProjectPublishButtonMorph methodsFor: 'constants' stamp: 'mu 6/18/2005 22:44'!
defaultPublishedColor
	^ Color red muchLighter! !


!NmProjectPublishButtonMorph methodsFor: 'initialize-release' stamp: 'mu 6/18/2005 22:39'!
initialize
	super initialize.
	self target: self;
		borderColor: #raised;
		 label: self defaultLabel font: TextStyle defaultFont;
		 setBalloonText: 'Publish this project' translated;
		 actionSelector: #publish! !


!NmProjectPublishButtonMorph methodsFor: 'accessing' stamp: 'mu 6/17/2005 18:33'!
project
	^Project current! !


!NmProjectPublishButtonMorph methodsFor: 'actions' stamp: 'mu 6/19/2005 00:14'!
publish
	| world saveOwner oldVersion |
	self canPublish
		ifFalse: [^ self].
	world _ self world
				ifNil: [^ Beeper beep].
	oldVersion _ self project currentVersionNumber.
	EToyProjectDetailsMorph
		getFullInfoFor: self project
		ifValid: [world setProperty: #'NetMorph:ProjectPublishing' toValue: true.
			saveOwner _ owner.
			self delete.
			[world project storeOnServerShowProgressOn: self forgetURL: true]
				ensure: [saveOwner addMorphFront: self]]
		expandedFormat: true.
	[[(self project currentVersionNumber > oldVersion
			and: [world setProperty: #'NetMorph:PublishedProject' toValue: true.
				true])
		or: [world isNetMorphProjectPublishCancelled]]
		whileFalse: [(Delay forSeconds: 3) wait].
	(world isNetMorphProjectPublishCancelled
			and: [world isNetMorphPublished not])
		ifTrue: [world setProperty: #'NetMorph:PublishedProject' toValue: false].
	world setProperty: #'NetMorph:ProjectPublishCancel' toValue: false.
	world setProperty: #'NetMorph:ProjectPublishing' toValue: false]
		forkAt: Processor userBackgroundPriority! !

!NmProjectPublishButtonMorph methodsFor: 'actions' stamp: 'mu 6/17/2005 18:30'!
showMenuFor:selector event: event
	
	| menu selection |
	menu _ CustomMenu new.
	menu 
		add: 'Stop Publishing' translated action: [self stopPublish].
	selection _ menu build startUpCenteredWithCaption: 'Publish options' translated.
	selection ifNil: [^self].
	selection value.

	^true! !

!NmProjectPublishButtonMorph methodsFor: 'actions' stamp: 'mu 6/18/2005 22:31'!
stopPublish
	| world |
	world _ self world ifNil: [^Beeper beep].
	world setProperty: #NetMorph:PublishedProject toValue: false.
	
	
	! !


!NmProjectPublishButtonMorph methodsFor: 'stepping' stamp: 'mu 6/18/2005 22:39'!
step
	self
		color: self computeColor.
	! !

!NmProjectPublishButtonMorph methodsFor: 'stepping' stamp: 'mu 6/17/2005 18:43'!
stepTime
	^1500! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmProjectPublishButtonMorph class
	instanceVariableNames: ''!

!NmProjectPublishButtonMorph class methodsFor: 'actions' stamp: 'mu 6/17/2005 16:53'!
open
	"NmProjectPublisherMorph open"
	^self new openInWorld! !


Error subclass: #NmProjectSortFailed
	instanceVariableNames: 'sortOptionString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Project'!

!NmProjectSortFailed methodsFor: 'printing' stamp: 'mu 7/3/2005 23:02'!
messageText
	messageText ifNil: [messageText _ self sortOptionString].
	^messageText
	! !


!NmProjectSortFailed methodsFor: 'accessing' stamp: 'mu 7/3/2005 22:58'!
sortOptionString
	^sortOptionString! !

!NmProjectSortFailed methodsFor: 'accessing' stamp: 'mu 7/3/2005 23:07'!
sortOptionString: aString
	sortOptionString _ aString asString capitalized! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmProjectSortFailed class
	instanceVariableNames: ''!

!NmProjectSortFailed class methodsFor: 'instance creation' stamp: 'mu 7/3/2005 23:04'!
sortOptionString: aString 
	^ self new sortOptionString: aString; signal! !
