RmtRpcConnector subclass: #NmRemoteConnector
	instanceVariableNames: ''
	classVariableNames: 'CriticalSemaphore'
	poolDictionaries: ''
	category: 'NetMorph-Network-RPC'!

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 5/29/2004 19:08'!
basicCallCatchAndGo: morphByteArray 
	^ self send: #catchAndGo: arguments: morphByteArray by: #none
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 5/29/2004 19:09'!
basicCallCatchAndGo: morphByteArray x: x y: y 
	| args |
	args _ {morphByteArray. x. y}.
	^ self send: #catchAndGo:x:y: arguments: args by: #DataStream
		
	! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 7/24/2005 13:14'!
basicCallDispatch: uuidString to: target selector: selector 
	| args |
	args _ {uuidString. target. selector}.
	^ self send: #dispatch:to:selector: arguments: args by: #DataStream
		
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 5/29/2004 19:10'!
basicCallDispatch: uuidString to: target selector: selector withArguments: arguments 
	| args |
	args _ {uuidString. target. selector. arguments}.
	^ self send: #dispatch:to:selector:withArguments: arguments: args by: #ReferenceStream
		
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 5/29/2004 19:11'!
basicCallFindBy: uuidString 
	| args |
	args _ {uuidString}.
	^ self send: #findBy: arguments: args by: #DataStream
		
	
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 7/2/2005 22:11'!
basicCallGetNumberOfProjectsMatches: matchString matchOptions: matchOptionString
	| args |
	args _ {matchString. matchOptionString}.
	^ self send: #getNumberOfProjectsMatches:matchOptions: arguments: args by: #DataStream
		
	
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 6/20/2005 00:07'!
basicCallGetProjectInfo: projectName 
	| args |
	args _ {projectName}.
	^ self send: #getProjectInfo: arguments: args by: #DataStream
		
	
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 7/2/2005 22:25'!
basicCallGetProjectNamesFrom: start to: end matches: matchString matchOptions: matchOptionString sortOptions: sortOptionString
	| args |
	args _ {start. end. matchString. matchOptionString. sortOptionString}.
	^ self send: #getProjectNamesFrom:to:matches:matchOptions:sortOptions: arguments: args by: #DataStream
		
	
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 6/20/2005 00:06'!
basicCallGetProjectThumbnail: projectName 
	| args |
	args _ {projectName}.
	^ self send: #getProjectThumbnail: arguments: args by: #DataStream
		
	
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 6/20/2005 00:05'!
basicCallGetProject: projectName 
	| args |
	args _ {projectName}.
	^ self send: #getProject: arguments: args by: #DataStream
		
	
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 6/16/2005 23:26'!
basicCallTakeAPicture: shrunkBySize
	| args |
	args _ {shrunkBySize}.
	^ self send: #takeAPicture: arguments: args by: #DataStream
		
	
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 8/3/2005 10:00'!
basicRedirectIpAndPortOf: uuidString 
	| args |
	args := {uuidString}.
	^ self send: #redirectIpAndPortOf: arguments: args by: #DataStream
		
	
		! !


!NmRemoteConnector methodsFor: 'calling' stamp: 'kuri-t 1/24/2003 14:06'!
callCatchAndGo: morphByteArray 
	| ret |
	ret _ nil.
	NmProcessManager
		critical: [ret _ self basicCallCatchAndGo: morphByteArray]
		ifError: [:ex | 
			NmProcessManager releaseAllLockedProcesses.
			ex pass].
	^ ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'MU 12/29/2002 17:43'!
callCatchAndGo: morphByteArray x: x y: y 
	| ret |
	ret _ nil.
	NmProcessManager
		critical: [ret _ self
						basicCallCatchAndGo: morphByteArray
						x: x
						y: y]
		ifError: [:ex | 
			NmProcessManager releaseAllLockedProcesses.
			ex pass].
	^ ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'MU 12/29/2002 17:43'!
callDispatch: uuidString to: target selector: selector 
	| ret |
	ret _ nil.
	NmProcessManager
		critical: [ret _ self
						basicCallDispatch: uuidString
						to: target
						selector: selector]
		ifError: [:ex | 
			NmProcessManager releaseAllLockedProcesses.
			ex pass].
	^ ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'MU 12/29/2002 17:44'!
callDispatch: uuidString to: target selector: selector withArguments: arguments 
	| ret |
	ret _ nil.
	NmProcessManager
		critical: [ret _ self
						basicCallDispatch: uuidString
						to: target
						selector: selector
						withArguments: arguments]
		ifError: [:ex | 
			NmProcessManager releaseAllLockedProcesses.
			ex pass].
	^ ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'MU 12/29/2002 17:44'!
callFindBy: uuidString 
	| ret |
	ret _ nil.
	NmProcessManager
		critical: [ret _ self basicCallFindBy: uuidString]
		ifError: [:ex | 
			NmProcessManager releaseAllLockedProcesses.
			ex pass].
	^ ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'mu 7/26/2005 01:52'!
callGetNumberOfProjectsMatches: matchString matchOptions: matchOptionString 
	| ret |
	ret _ 0.
	ret _ self basicCallGetNumberOfProjectsMatches: matchString matchOptions: matchOptionString.
	^ ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'mu 6/20/2005 01:23'!
callGetProjectInfo: projectName
	| ret |
	ret _ nil.
	ret _ self basicCallGetProjectInfo: projectName.
	^ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'mu 7/26/2005 01:52'!
callGetProjectNamesFrom: start to: end matches: matchString matchOptions: matchOptionString sortOptions: sortOptionString 
	| ret |
	ret _ #().
	[ret _ self
				basicCallGetProjectNamesFrom: start
				to: end
				matches: matchString
				matchOptions: matchOptionString
				sortOptions: sortOptionString]
		on: RmtNetworkError
		do: [:ex | ex inspect].
	^ ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'mu 6/20/2005 01:22'!
callGetProjectThumbnail: projectName 
	| ret |
	ret _ nil.
	ret _ self basicCallGetProjectThumbnail: projectName.
	^ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'mu 6/20/2005 01:18'!
callGetProject: projectName 
	| ret |
	ret _ nil.
	ret _ self basicCallGetProject: projectName.
	^Project loadFrom: ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'mu 8/3/2005 10:00'!
callRedirectIpAndPortOf: uuidString 
	| ret |
	ret := nil.
	NmProcessManager
		critical: [ret := self basicRedirectIpAndPortOf: uuidString]
		ifError: [:ex | 
			NmProcessManager releaseAllLockedProcesses.
			ex pass].
	^ ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'mu 6/16/2005 23:39'!
callTakeAPicture: shrunkBySize
	| ret |
	ret _ nil.
	ret _ self basicCallTakeAPicture: shrunkBySize.
	^Form fromCompactBytes: ret uncompressOnDemand! !


!NmRemoteConnector methodsFor: 'initialize' stamp: 'mu 7/30/2005 03:18'!
connect: ipAddressOrHost port: portNumber timeout: timeoutSeconds 
	| ret |
	ret _ nil.
	
	NmProcessManager
		critical: [ret _ Cursor execute
						showWhile: [super
								connect: ipAddressOrHost
								port: portNumber
								timeout: timeoutSeconds]]
		ifError: [:ex | 
			NmProcessManager releaseAllLockedProcesses.
			ex pass].
	^ ret! !


!NmRemoteConnector methodsFor: 'factory' stamp: 'mu 5/29/2004 18:52'!
messageClass
	^NmRpcMessage! !


!NmRemoteConnector methodsFor: 'private-sending' stamp: 'mu 5/29/2004 19:03'!
send: selector arguments: args by: encoder
	^self send: selector arguments: args by: encoder timeout: self class timeoutSeconds ! !

!NmRemoteConnector methodsFor: 'private-sending' stamp: 'mu 5/29/2004 19:01'!
send: selector arguments: args by: encoder timeout: timeoutSecs 
	| msg |
	msg _ NmRpcMessage
				selector: selector
				arguments: args
				encoder: encoder.
	^ self sendData: msg rawData timeout: timeoutSecs! !


!NmRemoteConnector methodsFor: 'private' stamp: 'mu 8/2/2005 07:19'!
signalExceptionFrom: exceptionArray 
	| exception |
	exception := self buildExceptionFrom: exceptionArray.
	exception class name = #NmNoSuchMorph
		ifTrue: [| localMorph | 
			localMorph := NmFinder
						findMorphBy: exception uuidString
						ifNone: [].
			localMorph notNil
				ifTrue: [
			NmTranscript cr;crShow: 'Unneeded exception so just ignore...'.
		"Unneeded exception so just ignore..." ^ self]].
	exception signal! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmRemoteConnector class
	instanceVariableNames: 'connectionPool'!

!NmRemoteConnector class methodsFor: 'utility' stamp: 'mu 7/30/2005 03:02'!
callFindBy: uuid retry: numberOfRetries 
	numberOfRetries
		timesRepeat: [NmWorldMap default
				survivorsDo: [:ipAndPort | 
					| connector return | 
					[connector _ self connect: ipAndPort first port: ipAndPort last.
					return _ connector callFindBy: uuid asString]
								on: RmtNetworkError
								do: [:ex | 
									NmTranscript crShow: '#callFindBy: cannot find: ' , uuid asString.
									ActiveWorld netMorphProxyCache removeKey: uuid ifAbsent:[].
									NmWorldMap default removeAtAddress: ipAndPort.
									ex return: nil].
					return isNil
						ifFalse: [^ return]].
			(Delay forSeconds: 1) wait].
	^ nil! !

!NmRemoteConnector class methodsFor: 'utility' stamp: 'mu 5/31/2004 01:00'!
closeAllConnections
	self connectionPool ifNotNilDo: [:cp | cp release]! !


!NmRemoteConnector class methodsFor: 'accessing' stamp: 'MU 11/29/2002 15:57'!
connectionPool
	^connectionPool! !


!NmRemoteConnector class methodsFor: 'instance creation' stamp: 'mu 5/10/2005 21:25'!
connect: ipAddressOrHost port: portNumber timeout: timeoutSecs 
	
	^self connectionPool connect: ipAddressOrHost port: portNumber asInteger timeout: timeoutSecs! !


!NmRemoteConnector class methodsFor: 'constants' stamp: 'MU 12/3/2002 11:39'!
defaultPort
	^44445! !

!NmRemoteConnector class methodsFor: 'constants' stamp: 'mu 7/26/2005 02:07'!
defaultTimeoutSeconds
	^7! !


!NmRemoteConnector class methodsFor: 'class initialization' stamp: 'mu 5/31/2004 00:59'!
initialize
	"NmRemoteConnector initialize"
	connectionPool _ RmtConnectorPool connectorClass: self.! !


RmtTcpService subclass: #NmRemoteService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Network-RPC'!

!NmRemoteService methodsFor: 'factory' stamp: 'mu 5/17/2004 01:42'!
defaultAcceptorClass
	^ Smalltalk at: #NmServiceHandler ifAbsent: []! !


RmtRpcMessage subclass: #NmRpcMessage
	instanceVariableNames: 'selectorIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Network-RPC'!

!NmRpcMessage methodsFor: 'initialize-release' stamp: 'mu 5/29/2004 19:02'!
extractHeaderAttributeFromTagChar: tagChar on: headerStream 
	"do nothing"! !

!NmRpcMessage methodsFor: 'initialize-release' stamp: 'mu 5/29/2004 18:47'!
extractHeaderBasicAttributesFrom: headerStream 
	| selectorIndicator |
	super extractHeaderBasicAttributesFrom: headerStream.
	selectorIndicator _ headerStream next.
	selectorIndicator ifNil: [^selectorIndex _ 0]. 	 
	selectorIndex _ selectorIndicator asciiValue.
	! !


!NmRpcMessage methodsFor: 'formats' stamp: 'mu 5/29/2004 18:47'!
headerOn: aStream
	selectorIndex ifNotNil: [aStream nextPut: selectorIndex].	
	! !


!NmRpcMessage methodsFor: 'accessing' stamp: 'mu 5/29/2004 19:34'!
realSelector
	^self class selectorOf:  selectorIndex! !

!NmRpcMessage methodsFor: 'accessing' stamp: 'mu 5/29/2004 19:22'!
receiver
	^'' ! !

!NmRpcMessage methodsFor: 'accessing' stamp: 'mu 5/29/2004 19:22'!
selector
	^self realSelector ifNil: [''] ! !

!NmRpcMessage methodsFor: 'accessing' stamp: 'mu 5/29/2004 18:47'!
selectorIndex: anIntegerOfSelectorIndex
	selectorIndex _ anIntegerOfSelectorIndex asNumber! !


!NmRpcMessage methodsFor: 'actions' stamp: 'mu 5/29/2004 19:53'!
restoreObject
	| tp |
	tp _ self type.
	tp == #send
		ifTrue: [^ Array
				with: self selector asSymbol
				with: (encoder == #none
						ifTrue: [Array with: self basicRestoreObject]
						ifFalse: [self basicRestoreObject])].
	^ super restoreObject! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmRpcMessage class
	instanceVariableNames: 'selectorIndexArray'!

!NmRpcMessage class methodsFor: 'class initialization' stamp: 'mu 5/29/2004 18:33'!
initialize
	"self initialize"
	super initialize.
	self initSelectorIndexArray.
	! !

!NmRpcMessage class methodsFor: 'class initialization' stamp: 'mu 8/3/2005 10:02'!
initSelectorIndexArray
	"self initSelectorIndexArray"
	| selectors seviceCats |
	selectors := OrderedCollection new.
	seviceCats := NmServiceHandler organization categories select: [:each | each beginsWith: 'service'].
	seviceCats do: [:eachCat | 
		selectors addAll: (NmServiceHandler organization listAtCategoryNamed: eachCat)].
	selectorIndexArray := selectors asArray.! !


!NmRpcMessage class methodsFor: 'accessing' stamp: 'mu 5/29/2004 18:32'!
selectorIndexArray
	^selectorIndexArray! !


!NmRpcMessage class methodsFor: 'actions' stamp: 'mu 5/29/2004 18:32'!
selectorIndexOf: selectorOfCommand	
	^selectorIndexArray indexOf: selectorOfCommand! !

!NmRpcMessage class methodsFor: 'actions' stamp: 'mu 5/29/2004 18:32'!
selectorOf: selectorIndex
	^selectorIndexArray at: selectorIndex ifAbsent:[]! !


!NmRpcMessage class methodsFor: 'instance creation' stamp: 'mu 5/29/2004 19:27'!
selector: selector arguments: args encoder: encoder 
	| inst |
	inst _ self new.
	inst type: #send.
	inst selectorIndex: (self selectorIndexOf: selector).
	inst arguments: args.
	inst body: (self stream: args by: encoder).
	inst encoder: encoder.
	^ inst! !


RmtRpcAcceptor subclass: #NmServiceHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Network-RPC'!

!NmServiceHandler methodsFor: 'service warp' stamp: 'kuri-t 1/24/2003 15:49'!
catchAndGo: morphByteArray 
	^ self class catcher catchAndGo: morphByteArray! !

!NmServiceHandler methodsFor: 'service warp' stamp: 'mu 12/6/2002 10:29'!
catchAndGo: morphByteArray x: x y: y 
	
	^self class catcher catchAndGo: morphByteArray x: x y: y ! !


!NmServiceHandler methodsFor: 'service dispatch' stamp: 'mu 12/6/2002 10:30'!
dispatch: uuidString to: target selector: selector
	^self class dispatcher dispatch: uuidString to: target selector: selector
	! !

!NmServiceHandler methodsFor: 'service dispatch' stamp: 'mu 12/6/2002 10:30'!
dispatch: uuidString to: target selector: selector withArguments: arguments 
	^self class dispatcher dispatch: uuidString to: target selector: selector withArguments: arguments ! !


!NmServiceHandler methodsFor: 'private' stamp: 'mu 7/24/2005 13:20'!
efficientEncoderForReturn: object
	object isProxy ifTrue: [^#DataStream].
	object isForm ifTrue: [^#DataStream].
	^super efficientEncoderForReturn: object! !


!NmServiceHandler methodsFor: 'service find' stamp: 'mu 12/6/2002 10:30'!
findBy: uuidString
	^self class finder findBy: uuidString! !

!NmServiceHandler methodsFor: 'service find' stamp: 'mu 8/3/2005 10:02'!
redirectIpAndPortOf: uuidString
	^self class finder redirectIpAndPortOf: uuidString! !


!NmServiceHandler methodsFor: 'service project' stamp: 'mu 7/2/2005 22:12'!
getNumberOfProjectsMatches: matchString matchOptions: matchOptionString
	^ self class projectServer getNumberOfProjectsMatches: matchString matchOptions: matchOptionString! !

!NmServiceHandler methodsFor: 'service project' stamp: 'mu 6/20/2005 01:42'!
getProjectInfo: projectName
	^ self class projectServer getProjectInfo: projectName! !

!NmServiceHandler methodsFor: 'service project' stamp: 'mu 7/2/2005 22:00'!
getProjectNamesFrom: start to: end matches: matchString matchOptions: matchOptionString sortOptions: sortOptionString
	^ self class projectServer getProjectNamesFrom: start to: end matches: matchString matchOptions: matchOptionString sortOptions: sortOptionString! !

!NmServiceHandler methodsFor: 'service project' stamp: 'mu 6/20/2005 01:42'!
getProjectThumbnail: projectName
	^ self class projectServer getProjectThumbnail: projectName ! !

!NmServiceHandler methodsFor: 'service project' stamp: 'mu 6/20/2005 01:42'!
getProject: projectName 
	^ self class projectServer getProject: projectName ! !

!NmServiceHandler methodsFor: 'service project' stamp: 'mu 6/16/2005 23:37'!
takeAPicture: shrunkBySize
	^ self class projectServer takeAPicture: shrunkBySize! !


!NmServiceHandler methodsFor: 'receiving' stamp: 'mu 7/2/2005 22:24'!
handleReceived: messageLikeObject 
	"Override if you wish"
	RmtDebug crShow: #handleReceived.
	RmtDebug crShow: messageLikeObject.
	"messageLikeObject inspect".
	
	^self perform: messageLikeObject first withArguments: messageLikeObject second.
	! !


!NmServiceHandler methodsFor: 'factory' stamp: 'mu 5/29/2004 18:52'!
messageClass
	^NmRpcMessage! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmServiceHandler class
	instanceVariableNames: 'catcher dispatcher finder projectServer'!

!NmServiceHandler class methodsFor: 'accessing' stamp: 'MU 11/29/2002 16:52'!
catcher
	^catcher! !

!NmServiceHandler class methodsFor: 'accessing' stamp: 'MU 11/29/2002 16:52'!
dispatcher 
	^dispatcher! !

!NmServiceHandler class methodsFor: 'accessing' stamp: 'MU 11/29/2002 16:52'!
finder   
	^finder  ! !

!NmServiceHandler class methodsFor: 'accessing' stamp: 'mu 6/16/2005 22:57'!
projectServer
	^projectServer! !


!NmServiceHandler class methodsFor: 'private' stamp: 'mu 7/23/2005 19:50'!
classNamed: className
	^Smalltalk at: className asSymbol ifAbsent:[]! !

!NmServiceHandler class methodsFor: 'private' stamp: 'mu 8/4/2005 07:48'!
create: className 
	| cls |
	cls := self classNamed: className.
	^ cls
		ifNil: [NmError signal: 'No such class: ' translated , className]
		ifNotNil: [cls new]! !


!NmServiceHandler class methodsFor: 'class initialization' stamp: 'mu 7/23/2005 19:54'!
initialize
	"NmServiceHandler initialize"
	NmServerManager isMapServerOnlyImage ifTrue: [^self].
	catcher _ self create: #NmCatcher.
	dispatcher _ self create: #NmDispatcher.
	finder _ self create: #NmFinder.
	projectServer _ self create: #NmProjectServer.! !

!NmServiceHandler class methodsFor: 'class initialization' stamp: 'mu 7/23/2005 19:54'!
initializeForDebug
	"NmServiceHandler initializeForDebug"
	catcher _ self create: #NmMockCatcher.
	dispatcher _ self create: #NmMockDispatcher.
	finder _ self create: #NmMockFinder.
	projectServer _ self create: #NmMockProjectServer.! !

NmRemoteConnector initialize!
NmRpcMessage initialize!
NmServiceHandler initialize!