NmAbstractInitializer subclass: #NmServerInitializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Server'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmServerInitializer class
	instanceVariableNames: ''!

!NmServerInitializer class methodsFor: 'system startup' stamp: 'mu 7/13/2005 20:44'!
lightStartUp
	"NmServerInitializer startUp"
	NmFlapSetup addFlap.
	NmServerSettings load.
	NmServerSettings shouldRunMapServer
		ifTrue: [NmServerManager isMapServerRunning
				ifFalse: [NmServerManager startMapServer].
			NmWorldMapLocationBroadcaster default isRunning
				ifFalse: [NmWorldMapLocationBroadcaster default startAfter: 3]].
	NmWorldMapServer default clearMapsNotUsedFor: 1! !

!NmServerInitializer class methodsFor: 'system startup' stamp: 'mu 7/9/2005 15:52'!
startUp
	"NmServerInitializer startUp"
	NmFlapSetup addFlap.
	NmServerSettings load.
	NmServerSettings shouldRunMapServer
		ifTrue: [NmServerManager startMapServer.
			NmWorldMapLocationBroadcaster default startAfter: 3].
	NmServerSettings saveMapServerPort ifFalse: [NmServerSettings mapServerPort: -1.  "reset port"].
	NmWorldMapServer default clearMapsNotUsedFor: 1.
	! !


NmBaseSettings subclass: #NmServerSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Server'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmServerSettings class
	instanceVariableNames: ''!

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:11'!
allocateByRandom
	^ self properties at: #allocateByRandom ifAbsentPutValue: false! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:08'!
allocateByRandom: aBoolean 
	self properties at: #allocateByRandom put: aBoolean == true.
	self changed: #allocateByRandom.
	! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:25'!
level1Matrix
	^ self properties at: #level1Matrix ifAbsentPutValue: self defaultLevel1Matrix! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 7/20/2005 21:04'!
level1Matrix: point
	self properties at: #level1Matrix put: (Point readFrom: point asString).
	self changed: #level1Matrix.
	! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:25'!
level2Matrix
	^ self properties at: #level2Matrix ifAbsentPutValue: self defaultLevel2Matrix! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 7/20/2005 21:04'!
level2Matrix: point
	self properties at: #level2Matrix put: (Point readFrom: point asString).
	self changed: #level2Matrix.
	! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:25'!
level3Matrix
	^ self properties at: #level3Matrix ifAbsentPutValue: self defaultLevel3Matrix! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 7/20/2005 21:04'!
level3Matrix: point
	self properties at: #level3Matrix put: (Point readFrom: point asString).
	self changed: #level3Matrix.
	! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 5/29/2005 03:12'!
mapServerPort
	^ self properties at: #mapServerPort ifAbsentPutValue: self defaultMapServerPort! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 6/2/2005 22:58'!
mapServerPort: aValue 
	"NmServerSettings mapServerPort: 8080"
	| aNumber |
	[aNumber _ aValue asNumber]
		on: Error
		do: [^ false].
	aNumber < 1 ifTrue: [aNumber _ self defaultMapServerPort].
	self properties at: #mapServerPort put: aNumber.
	self changed: #mapServerPort.
	self shouldRunMapServer
		ifTrue: [NmServerManager startMapServerWithBroadcaster]! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 6/15/2005 18:58'!
saveMapServerPort
	^ self properties at: #saveMapServerPort ifAbsentPutValue: self defaultSaveMapServerPort! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 6/2/2005 22:53'!
saveMapServerPort: aBoolean 
	| save |
	save _ aBoolean == true.
	self properties at: #saveMapServerPort put: save.
	! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 6/1/2005 16:38'!
shouldRunMapServer
	^ self properties at: #shouldRunMapServer ifAbsentPutValue: true! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 6/1/2005 16:37'!
shouldRunMapServer: aBoolean 
	| shouldRun |
	shouldRun _ aBoolean == true.
	self properties at: #shouldRunMapServer put: shouldRun.
	shouldRun
		ifTrue: [NmServerManager startMapServerWithBroadcaster]
		ifFalse: [NmServerManager stopMapServerWithBroadcaster]! !


!NmServerSettings class methodsFor: 'actions' stamp: 'mu 7/20/2005 19:22'!
broadcastingWarpPorts
	^ self availableWarpPorts - self defaultWarpPortOffset! !

!NmServerSettings class methodsFor: 'actions' stamp: 'mu 5/29/2005 03:45'!
localMapServerUrl
	^'http://', NmBaseUtil localAddress, '/', self defaultMapServerTargetName! !

!NmServerSettings class methodsFor: 'actions' stamp: 'mu 7/20/2005 20:49'!
toggleAllocateByRandom
	self allocateByRandom: self allocateByRandom not! !

!NmServerSettings class methodsFor: 'actions' stamp: 'mu 6/2/2005 22:47'!
toggleAutoTrimMapServers
	self autoTrimMapServers: self autoTrimMapServers not! !

!NmServerSettings class methodsFor: 'actions' stamp: 'mu 5/30/2005 18:17'!
toggleMapServerRunning
	self shouldRunMapServer: self isMapServerRunning not! !

!NmServerSettings class methodsFor: 'actions' stamp: 'mu 6/2/2005 23:00'!
toggleSaveMapServerPort
	self saveMapServerPort: self saveMapServerPort not! !


!NmServerSettings class methodsFor: 'constants' stamp: 'mu 7/20/2005 19:23'!
defaultLevel1Matrix
	^2@3! !

!NmServerSettings class methodsFor: 'constants' stamp: 'mu 7/20/2005 19:23'!
defaultLevel2Matrix
	^3@3! !

!NmServerSettings class methodsFor: 'constants' stamp: 'mu 7/20/2005 19:23'!
defaultLevel3Matrix
	^2@3! !

!NmServerSettings class methodsFor: 'constants' stamp: 'mu 6/15/2005 18:58'!
defaultSaveMapServerPort
	^NmServerManager isMapServerOnlyImage! !


!NmServerSettings class methodsFor: 'testing' stamp: 'mu 5/30/2005 18:12'!
isMapServerRunning
	"NmServerSettings isMapServerRunning"
	^NmServerManager isMapServerRunning! !


NmAbstractSettingsMorph subclass: #NmServerSettingsMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Server'!

!NmServerSettingsMorph methodsFor: 'actions' stamp: 'mu 7/20/2005 20:52'!
allocateByRandom
	^self settingClass allocateByRandom! !

!NmServerSettingsMorph methodsFor: 'actions' stamp: 'mu 7/20/2005 21:14'!
toggleAllocateByRandom
	self settingClass toggleAllocateByRandom.
	self resetGridFields! !

!NmServerSettingsMorph methodsFor: 'actions' stamp: 'mu 6/3/2005 02:05'!
viewMaps
	| mapServer mapNames mapEntries  sele map |
	mapServer _ NmWorldMapServer default.
	mapEntries _ mapServer worldMaps.
	mapEntries isEmpty ifTrue: [^self inform: 'No maps on this server'].
	mapNames _ mapEntries keys asArray.
	sele _ (SelectionMenu labelList:  ( mapNames collect: [:each | FileDirectory baseNameFor: each ] ) selections: mapNames) startUp.
	map _ mapServer worldMaps at: sele ifAbsent:[].
	map ifNotNilDo: [:m | self viewMapOn: m].! !


!NmServerSettingsMorph methodsFor: 'private' stamp: 'mu 6/2/2005 22:06'!
buildListButtonRow
	| button |
	button _  self
		buildButtonOn: self
		action: #viewMaps
		label: 'view'
		help: 'view maps'.
	^button! !

!NmServerSettingsMorph methodsFor: 'private' stamp: 'mu 7/20/2005 21:26'!
createAllocationPolicyRow
	| first checkBox second textField third fourth row |
	first _ self buildRowLabeled: 'allocate by random: '.
	checkBox _ self
				buildCheckBoxOn: self
				action: #toggleAllocateByRandom
				getSelector: #allocateByRandom
				help: 'Allocate map enty point by random'.
	first addMorphBack: checkBox.
	
	second _ self buildRowLabeled: 'grid 1:'.
	textField _ self buildTextField: #level1Matrix help: 'set map entry minimal level groups grid'.
	second name: 'grid1'.
	second addMorphBack: textField.

	third _ self buildRowLabeled: 'grid 2:'.
	textField _ self buildTextField: #level2Matrix help: 'set map entry middle level groups grid'.
	third name: 'grid2'.
	third addMorphBack: textField.

	fourth _ self buildRowLabeled: 'grid 3:'.
	textField _ self buildTextField: #level3Matrix help: 'set map entry largest level groups grid'.
	fourth name: 'grid3'.
	fourth addMorphBack: textField.
	
	row _ self
				buildRow: first
				with: second
				with: third
				with: fourth.
	self addMorphBack: row.
	^ row! !

!NmServerSettingsMorph methodsFor: 'private' stamp: 'mu 4/7/2005 23:07'!
createMapPathRow
	| row textField |
	row _ self buildRowLabeled: 'map path: '.
	textField _ self buildTextField: #mapPath.
	row addMorphBack: textField.
	self addMorphBack: row.
	^row! !

!NmServerSettingsMorph methodsFor: 'private' stamp: 'mu 6/3/2005 09:24'!
createMapServerRow
	| first checkBox second third textField row fourth |
	first _ self buildRowLabeled: 'run map server: '.
	checkBox _ self
				buildCheckBoxOn: self settingClass
				action: #toggleMapServerRunning
				getSelector: #isMapServerRunning
				help: 'Run the map server'.
	first addMorphBack: checkBox.
	NmServerManager isMapServerOnlyImage 
		ifFalse: [second _ self buildRowLabeled: 'auto run: '.
			checkBox _ self
						buildCheckBoxOn: self settingClass
						action: #toggleAutoTrimMapServers
						getSelector: #autoTrimMapServers
						help: 'Auto run map server if not available'.
			second addMorphBack: checkBox]
		ifTrue: [second _ nil].
	third _ self buildRowLabeled: 'save port: '.
	checkBox _ self
				buildCheckBoxOn: self settingClass
				action: #toggleSaveMapServerPort
				getSelector: #saveMapServerPort
				help: 'Port number is saved through snapshots'.
	third addMorphBack: checkBox.
	fourth _ self buildRowLabeled: 'port: '.
	textField _ self buildTextField: #mapServerPort.
	fourth addMorphBack: textField.
	row _ self
				buildRow: first
				with: second
				with: third
				with: fourth.
	self addMorphBack: row.
	^ row! !

!NmServerSettingsMorph methodsFor: 'private' stamp: 'mu 6/3/2005 02:03'!
createViewMapsRow
	| row |
	row _ self buildRowLabeled: 'view all maps:'.
	row addMorphBack: (self buildListButtonRow).
	self addMorphBack: row.
	^row! !

!NmServerSettingsMorph methodsFor: 'private' stamp: 'mu 7/20/2005 21:14'!
resetGridFields
	self allocateByRandom
		ifTrue: [self disableMorphsMatches: 'grid*']
		ifFalse: [self enableMorphsMatches: 'grid*']! !


!NmServerSettingsMorph methodsFor: 'initialization' stamp: 'mu 7/20/2005 21:06'!
createWindow
	| window |
	window _ super createWindow.
	self createMapServerRow.
	self createViewMapsRow.
	self createMapPathRow.
	self createAllocationPolicyRow.
	self createResetDefaultButtonRow.
	self resetGridFields.
	^ window! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmServerSettingsMorph class
	instanceVariableNames: ''!

!NmServerSettingsMorph class methodsFor: 'defaluts' stamp: 'ns 1/22/2003 17:19'!
labelString
	^ 'NetMorph Server setting'! !


!NmServerSettingsMorph class methodsFor: 'factory' stamp: 'ns 1/22/2003 16:41'!
settingClass
	^ NmServerSettings! !


!NmServerSettingsMorph class methodsFor: 'constants' stamp: 'mu 7/20/2005 20:09'!
windowExtent
	^ 500 @ 160! !


NmBaseUtil subclass: #NmServerUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Server'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmServerUtil class
	instanceVariableNames: ''!

!NmServerUtil class methodsFor: 'soap support' stamp: 'ns 1/23/2003 14:33'!
inspectRegisteredServices
	"NmServerUtil inspectRegisteredServices"
	SoapServiceHandler default serviceHome inspect! !

!NmServerUtil class methodsFor: 'soap support' stamp: 'mu 5/29/2005 03:48'!
runningTransportDescriptions
	"NmServerUtil runningTransportDescriptions"
	"Show what transport server(s) is running"
	| setup |
	(setup _ NmServerManager soapServerSetup)
		ifNil: [^ #()].
	^setup runningTransportDescriptions! !


Object subclass: #NmSoapServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Server'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmSoapServer class
	instanceVariableNames: 'default'!

!NmSoapServer class methodsFor: 'class initialization' stamp: 'mu 3/24/2003 02:01'!
basicInitialize
	default _ nil.
	self registerServices.! !

!NmSoapServer class methodsFor: 'class initialization' stamp: 'mu 3/12/2003 00:18'!
initialize
	self initializeAll! !

!NmSoapServer class methodsFor: 'class initialization' stamp: 'mu 6/7/2004 01:35'!
initializeAll
	"NmSoapServer initializeAll"
	self allSubclasses do:[:each | each initialize]! !


!NmSoapServer class methodsFor: 'accessing' stamp: 'mu 6/16/2005 18:41'!
default
	default
		ifNil: [default _ self basicNew initialize].
	^ default! !


!NmSoapServer class methodsFor: 'utilities' stamp: 'mu 6/7/2004 01:35'!
inspectRegisteredServices
	"NmSoapServer inspectRegisteredServices"
	SoapServiceHandler default serviceHome inspect! !


!NmSoapServer class methodsFor: 'instance creation' stamp: 'mu 3/13/2003 19:25'!
new
	self shouldNotImplement! !


!NmSoapServer class methodsFor: 'private' stamp: 'mu 5/29/2005 03:17'!
registerServiceNamed: serviceNameSymbol paramNames: anArrayOfParamNames
	| impl serv |
	impl := self default.
	serv := SoapService implementor: impl selector: serviceNameSymbol.
	serv signature: (SoapServiceSignature name: serviceNameSymbol asString paramNames: anArrayOfParamNames).
	serv targetObjectURI: (NmServerSettings mapServerUrl asUrl fullPath).
	SoapServiceHandler default add: serv.

	! !

NmSoapServer initialize!