NmError subclass: #NmLockFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-WorldMap'!


Object subclass: #NmPointAllocator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-WorldMap'!

!NmPointAllocator methodsFor: 'actions' stamp: 'mu 8/9/2005 10:16'!
emptyPointConsidering: existingPoints 
	| recomPoint randomPoint point |
	NmServerSettings allocateByRandom ifTrue: [^self randomPointConsidering: existingPoints].
	recomPoint := self recommendedPointAt: existingPoints size.
	point :=  (existingPoints includes: recomPoint)
		ifTrue: [randomPoint _ self randomPointConsidering: existingPoints]
		ifFalse: [recomPoint].
	{existingPoints. recomPoint. randomPoint} inspect.
	^point! !


!NmPointAllocator methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:27'!
level1Matrix
	^NmServerSettings level1Matrix! !

!NmPointAllocator methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:28'!
level1Matrix: aPoint
	NmServerSettings level1Matrix: aPoint! !

!NmPointAllocator methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:27'!
level2Matrix
	^NmServerSettings level2Matrix! !

!NmPointAllocator methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:28'!
level2Matrix: aPoint
	NmServerSettings level2Matrix: aPoint! !

!NmPointAllocator methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:27'!
level3Matrix
	^NmServerSettings level3Matrix! !

!NmPointAllocator methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:28'!
level3Matrix: aPoint
	NmServerSettings level3Matrix: aPoint! !


!NmPointAllocator methodsFor: 'private' stamp: 'mu 7/20/2005 01:18'!
level1Point: index 
	^self levelNPoint: index maxX: self level1Matrix x maxY: self level1Matrix y! !

!NmPointAllocator methodsFor: 'private' stamp: 'mu 7/20/2005 01:19'!
level2Point: index 
	^self levelNPoint: index maxX: self level2Matrix x maxY: self level2Matrix y! !

!NmPointAllocator methodsFor: 'private' stamp: 'mu 7/20/2005 01:19'!
level3Point: index 
	^self levelNPoint: index maxX: self level3Matrix x maxY: self level3Matrix y! !

!NmPointAllocator methodsFor: 'private' stamp: 'mu 7/20/2005 01:14'!
levelNPoint: index maxX: maxX maxY: maxY 
	| x y |
	(index between: 0 and: maxX * maxY - 1)
		ifFalse: [^ self
				levelNPoint: index - (maxX * maxY)
				maxX: maxX
				maxY: maxY].
	x _ index \\ maxX.
	y _ (index / maxX) floor.
	^ x @ y! !

!NmPointAllocator methodsFor: 'private' stamp: 'mu 7/20/2005 01:47'!
randomPointConsidering: existingPoints
	"NmWorldMap default emptyPointConsidering: {0@1. 0@0}"
	"NmWorldMap default emptyPointConsidering: {1@1. 0@0. 1@3. 2@3}"
	| maxPoint minPoint xSize ySize points |
	maxPoint _ existingPoints
				inject: 0 @ 0
				into: [:sum :eachPoint | sum max: eachPoint].
	minPoint _ existingPoints
				inject: maxPoint
				into: [:sum :eachPoint | sum min: eachPoint].
	xSize _ maxPoint x - minPoint x + 1.
	ySize _ maxPoint y - minPoint y + 1.
	points _ OrderedCollection new: xSize * ySize.
	minPoint x
		to: maxPoint x
		do: [:x | minPoint y
				to: maxPoint y
				do: [:y | points
						add: (Point x: x y: y)]].
	points removeAllFoundIn: existingPoints.
	points isEmpty
		ifTrue: [| candidate | 
			existingPoints
				detect: [:each | (candidate _ each fourNeighbors
								detect: [:ep | (existingPoints includes: ep) not]
								ifNone: []) notNil]
				ifNone: [].
			^ candidate].
	^ (points asSortedCollection: [:a :b | a y < b y]) first! !

!NmPointAllocator methodsFor: 'private' stamp: 'mu 8/9/2005 10:14'!
recommendedPointAt: index 
	| largeIndex largePoint middleIndex middlePoint delta deltaPoint point |
	largeIndex := (index / (self level3Matrix x * self level3Matrix y * self level2Matrix x * self level2Matrix y)) floor.
	largePoint := self level3Point: largeIndex.
	middleIndex := (index / (self level1Matrix x * self level1Matrix y)) floor.
	middlePoint := self level2Point: middleIndex.
	delta := index \\ (self level1Matrix x * self level1Matrix y).
	deltaPoint := self level1Point: delta.
	point _ largePoint * (self level3Matrix * self level2Matrix) + (middlePoint * self level1Matrix) + deltaPoint.
	^point * (1@-1)! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmPointAllocator class
	instanceVariableNames: 'default'!

!NmPointAllocator class methodsFor: 'instance creation' stamp: 'mu 7/20/2005 01:51'!
default
	default ifNil: [default _ self new].
	^default! !


!NmPointAllocator class methodsFor: 'class initialization' stamp: 'mu 7/20/2005 18:34'!
initialize
	default _ nil.
	! !


NmError subclass: #NmUnlockFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-WorldMap'!


Object subclass: #NmWorldMap
	instanceVariableNames: 'version map mapName oldLocalEntry hasChanged locker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-WorldMap'!

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 6/15/2005 00:55'!
adapt: aSoapCall targetTo: url
	| port |
	port _ url port.
	aSoapCall locator: (SoapTcpLocator
				host: url authority
				port: (port isNil
						ifTrue: [NmBaseSettings defaultExternalMapServerPort]
						ifFalse: [port])) .
	aSoapCall targetObjectURI: url fullPath.
	^aSoapCall! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 5/7/2005 10:25'!
callGetVersion
	| call |
	call _ self newCall.
	call methodName: 'getVersionNamed:'.
	call
		addParameter: (SoapVariable name: #mapName value: self mapName).
	^self invoke: call. 
	! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 4/21/2005 01:39'!
callListLoadableMapNames
	| call |
	call _ self newCall.
	call methodName: 'listAllMapNames'.
	^self invoke: call ! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 5/5/2005 23:30'!
callLoadNamed: mapNameStr
	| call |
	call _ self newCall.
	call methodName: 'getMapStringNamed:'.
	call
		addParameter: (SoapVariable name: #mapName value: mapNameStr).
	^self invoke: call 
	! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 5/13/2005 23:17'!
callRemoveEntry: uuidStr 
	| call |
	call _ self newCall.
	call methodName: 'removeEntryWith:named:'.
	call
		addParameter: (SoapVariable name: #uuidStr value: uuidStr).
	call
		addParameter: (SoapVariable name: #mapName value: self mapName).
	^self invoke: call ! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 4/21/2005 01:39'!
callStoreNamed: mapNameStr 
	| call |
	call _ self newCall.
	call methodName: 'putMapString:named:'.
	call
		addParameter: (SoapVariable name: #mapCSVString value: self csvString).
	call
		addParameter: (SoapVariable name: #mapName value: mapNameStr).
	^self invoke: call! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 5/13/2005 23:16'!
callUpdateLocalEntry
	| call |
	call _ self newCall.
	call methodName: 'updateEntryWith:named:'.
	call
		addParameter: (SoapVariable name: #mapEntryString value: self localEntry csvString).
	call
		addParameter: (SoapVariable name: #mapName value: self mapName).
	^self invoke: call. 
	! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 6/16/2005 00:50'!
fixCallTarget
	NmWorldMapLocationListener refresh.
	(NmServerManager isMapServerInstalled
			and: [NmServerManager isMapServerRunning])
		ifTrue: [NmBaseSettings mapServerUrl: NmBaseUtil localMapServerUrl.
			NmBaseSettings mapFromInternet
				ifTrue: [NmBaseSettings mapFromInternet: false]]! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 6/15/2005 00:52'!
invoke: aSoapCall 
	NmBaseSettings mapFromInternet
		ifFalse: [NmWorldMapLocationListener mapServerUrl
				ifNotNilDo: [:recomUrl | 
					self adapt: aSoapCall targetTo: recomUrl asUrl.
					NmBaseSettings mapServerUrl: recomUrl]].
	^ aSoapCall
		invokeAndReturnHandling: [:ex | 
			NmShortMessageMorph contents: ex messageText at: ActiveWorld center.
			self fixCallTarget.
			nil]! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 6/1/2005 17:16'!
newCall
	| call url port |
	url _ NmBaseSettings mapServerUrl asUrl.
	port _ url port.
	call _ (SoapCallEntry
				tcpHost: url authority
				port: (port isNil
						ifTrue: [NmBaseSettings defaultExternalMapServerPort]
						ifFalse: [port])) newCall.
	call targetObjectURI: url fullPath.
	call useColocation: true.
	^call! !


!NmWorldMap methodsFor: 'private' stamp: 'mu 5/10/2005 18:18'!
adjustEntryToNearest: anNmWorldMapEntry 
	| origPoint ents entPoints neighbors empties nearestPoint |
	origPoint _ anNmWorldMapEntry point.
	ents _ self entriesWithout: anNmWorldMapEntry.
	entPoints _ (ents
				collect: [:each | each point]) asSet.
	neighbors _ entPoints
				inject: Set new
				into: [:all :each | all addAll: each fourNeighbors;
						 yourself].
	empties _ neighbors removeAllFoundIn: entPoints;
				asSortedCollection: [:a :b | a y < b y].
	nearestPoint _ empties
				detectMin: [:each | each dist: origPoint].
	nearestPoint notNil
		ifTrue: [anNmWorldMapEntry point: nearestPoint.
			self forceRegister: anNmWorldMapEntry].
	^ anNmWorldMapEntry! !

!NmWorldMap methodsFor: 'private' stamp: 'mu 7/20/2005 01:53'!
emptyPointConsidering: existingPoints 
	"NmWorldMap default emptyPointConsidering: {0@1. 0@0}"
	"NmWorldMap default emptyPointConsidering: {1@1. 0@0. 1@3. 2@3}"
	^NmPointAllocator default emptyPointConsidering: existingPoints ! !

!NmWorldMap methodsFor: 'private' stamp: 'mu 5/31/2005 17:37'!
emptyPortConsidering: existingPorts 
	| interval removed |
	interval _ NmBaseSettings availableWarpPorts.
	removed _ interval asOrderedCollection removeAll: existingPorts;
				 yourself.
	^ removed
		ifEmpty: [NmBaseSettings defaultWarpPort]
		ifNotEmpty: [removed first]! !

!NmWorldMap methodsFor: 'private' stamp: 'mu 12/25/2004 00:54'!
normalizedDestinationStringFrom: destString 
	| url |
	url _ destString asUrl.
	^ url isNmUrl
		ifTrue: [url asString]
		ifFalse: [destString]! !

!NmWorldMap methodsFor: 'private' stamp: 'mu 5/10/2005 02:44'!
selectAloneEntries
	| allPoints aloneEnts |
	allPoints _ self allPoints.
	aloneEnts _ self entries
				select: [:eachEnt | (eachEnt point fourNeighbors
						 includesAnyOf: allPoints) not].
	^ aloneEnts! !


!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 7/29/2005 09:04'!
allConnectAddresses
	"NmWorldMap default allConnectAddresses"
	^self entries collect: [:each | each ipAndPortArray]! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 12/27/2004 01:42'!
atAddress: ipAndPortArray
	
	^self entries detect: [:each | each ipAndPortArray = ipAndPortArray] ifNone: []! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 8/4/2005 08:25'!
atAddress: ipAndPortArray ifAbsent: block
	^self entries detect: [:each | each ipAndPortArray = ipAndPortArray] ifNone: [block value]! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 5/10/2005 20:09'!
destinationNameAt: ipAndPortArray
	| ent |
	ent _ self atAddress: ipAndPortArray.
	^ ent ifNotNil:[ent destination]! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 3/23/2003 12:42'!
ipAndPortArrayAt: aPoint 
	^self ipAndPortArrayAt: aPoint ifAbsent: []! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 12/28/2004 00:27'!
ipAndPortArrayAt: aPoint ifAbsent: aBlock
	| ent |
	ent _ self atPoint: aPoint.
	ent	ifNil: [^ aBlock value].
	^ ent ipAndPortArray! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 5/10/2005 19:58'!
ipAndPortArrayFor: destinationEntry 
	| ent |
	ent _ destinationEntry isString
				ifTrue: [self atName: destinationEntry]
				ifFalse: [self at: destinationEntry id].
	^ ent isNil
		ifFalse: [ent ipAndPortArray]! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 12/29/2004 22:19'!
ipAndPortArrays
	^ self entries
		collect: [:each | each ipAndPortArray]! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 3/23/2003 12:42'!
ipAndPortAt: aPoint 
	^self ipAndPortAt: aPoint ifAbsent: []! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 12/28/2004 00:27'!
ipAndPortAt: aPoint ifAbsent: aBlock 
	| ent |
	ent _ self atPoint: aPoint.
	ent	ifNil: [^ aBlock value].
	^ ent ipAndPort! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 7/29/2005 19:46'!
neighborConnectAddresses
	"NmWorldMap default neighborConnectAddresses"
	| neighborPoints ipAndPorts |
	neighborPoints _ self localPoint fourNeighbors.
	ipAndPorts _ OrderedCollection new.
	neighborPoints
		do: [:each | 
			| entry | 
			entry _ self atPoint: each.
			entry notNil
				ifTrue: [ipAndPorts add: entry ipAndPortArray]].
	^ ipAndPorts! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 12/28/2004 00:28'!
points
	^self allPoints! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 12/27/2004 01:44'!
removeAtAddress: ipAndPortArray
	
	| ent |
	ent _ self atAddress: ipAndPortArray.
	ent isNil ifFalse: [self remove: ent]! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 12/25/2004 02:16'!
survivorsDo: aBlock 
	| allAddresses availableAddresses neighborAddresses otherAddresses |
	allAddresses _ self allConnectAddresses.
	availableAddresses _ NmAvailabilityChecker default availableAddresses.
	neighborAddresses _ self neighborConnectAddresses.
	(neighborAddresses intersection: availableAddresses)
		do: [:each | aBlock value: each].
	otherAddresses _ allAddresses reject:[:each | neighborAddresses includes: each].
	(otherAddresses intersection: availableAddresses)
		do: [:each | aBlock value: each]! !


!NmWorldMap methodsFor: 'local info' stamp: 'mu 6/13/2004 01:30'!
allLocalIdentifiers
	^ (ActiveWorld allMorphs
		reject: [:each | each isRenderer])
		collect: [:each | each identifier]! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 1/15/2005 02:15'!
localEntry
	"NmWorldMap default localEntry"
	^self at: self localId ifAbsent:[]! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 1/15/2005 01:47'!
localId
	^NmImageId current asString! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 12/24/2004 02:49'!
localIp
	| ent |
	ent _ self at: self localId ifAbsent: [self resetLocal].
	ent ifNil: [^''].
	^ent ip
	! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 12/30/2004 00:00'!
localIpAndPortArray
	"NmWorldMap default localIpAndPortArray"
	^ self localEntry isNil
		ifTrue: [{NmUtil localAddress. NmBaseSettings warpPort}]
		ifFalse: [self localEntry ipAndPortArray]! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 8/10/2005 09:38'!
localIp: aString
	| ent |
	ent := self localEntry.
	ent ifNil: [^self].
	ent ip:  aString.
	self updateWithLocalEntry.
	! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 5/14/2005 00:35'!
localName
	| ent |
	ent _ self at: self localId ifAbsent: [].
	ent ifNil: [^''].
	^ent destination
	! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 3/2/2005 01:40'!
localName: aString
	| ent |
	ent _ self localEntry.
	ent ifNil: [^self].
	ent name:  aString.
	
	! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 5/14/2005 00:22'!
localPoint
	| ent |
	ent _ self at: self localId ifAbsent: [].
	ent ifNil: [^nil].
	^ent point
	! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 8/10/2005 09:38'!
localPoint: aPoint
	| ent |
	ent := self localEntry.
	ent ifNil: [^self].
	ent point:  aPoint.
	self updateWithLocalEntry.! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 12/24/2004 02:49'!
localPort
	| ent |
	ent _ self at: self localId ifAbsent: [self resetLocal].
	ent ifNil: [^''].
	^ent port
	! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 8/10/2005 09:38'!
localPort: aString
	| ent |
	ent := self localEntry.
	ent ifNil: [^self].
	ent port:  aString.
	self updateWithLocalEntry.
	! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 5/13/2005 23:27'!
resetLocal
	"NmWorldMap default resetLocal"
	^self registerLocalEntry: self localId ! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 1/15/2005 02:14'!
resetLocalTo: uuid 
	self localEntry isNil
		ifTrue: [NmImageId resetTo: uuid.
			self registerLocalEntry: uuid]! !


!NmWorldMap methodsFor: 'accessing point' stamp: 'mu 12/26/2004 02:08'!
allPoints
	^self entries collect: [:each | each point]

! !

!NmWorldMap methodsFor: 'accessing point' stamp: 'mu 12/25/2004 00:44'!
atPoint: aPoint
	^self entries detect: [:each | each point = aPoint] ifNone: []

! !

!NmWorldMap methodsFor: 'accessing point' stamp: 'mu 12/25/2004 01:07'!
atPoint: aPoint ifAbsent: aBlock
	^self entries detect: [:each | each point = aPoint] ifNone: aBlock

! !

!NmWorldMap methodsFor: 'accessing point' stamp: 'mu 4/16/2003 02:30'!
deltaPointTo: destinationPoint
	| fromPoint toPoint |
	fromPoint _ self localPoint.
	toPoint _ destinationPoint.
	^ toPoint - fromPoint * (ActiveWorld extent) * (1 @ -1)! !

!NmWorldMap methodsFor: 'accessing point' stamp: 'mu 3/2/2005 00:28'!
emptyPoint
	^self emptyPointConsidering: self allPoints! !

!NmWorldMap methodsFor: 'accessing point' stamp: 'mu 12/25/2004 00:44'!
includesPoint: aPoint
	^(self atPoint: aPoint) notNil

! !

!NmWorldMap methodsFor: 'accessing point' stamp: 'mu 12/25/2004 02:59'!
pointOf: destinationName 
	"NmWorldMap pointOf: 'nm://Smalltalk:37458/' asUrl"
	"NmWorldMap pointOf: 'nm://qwerty:37458/'"
	| ent |
	ent _ self atName: destinationName.
	
	^ent notNil ifTrue: [ent point]! !

!NmWorldMap methodsFor: 'accessing point' stamp: 'mu 1/24/2005 02:26'!
pointsWithoutLocal
	^self allPoints reject: [:each | each = self localPoint]

! !


!NmWorldMap methodsFor: 'changing' stamp: 'mu 7/5/2005 20:59'!
allUnchanged
	self map
		valuesDo: [:each | each unchanged].
	self unchanged.
	! !

!NmWorldMap methodsFor: 'changing' stamp: 'mu 2/1/2005 23:52'!
changed
	super changed.
	hasChanged _ true! !

!NmWorldMap methodsFor: 'changing' stamp: 'mu 1/22/2005 01:56'!
hasChanged
	hasChanged ifNil: [hasChanged _ false].
	^hasChanged! !

!NmWorldMap methodsFor: 'changing' stamp: 'mu 4/10/2005 00:26'!
unchanged
	hasChanged _ false! !


!NmWorldMap methodsFor: 'accessing name' stamp: 'mu 1/14/2005 00:59'!
allWorldNames
	^map collect: [:each | each destination]
	! !

!NmWorldMap methodsFor: 'accessing name' stamp: 'mu 1/7/2005 01:22'!
atName: destinationName
	| nm |
	nm _ self normalizedDestinationStringFrom: destinationName. 
	^self entries detect: [:each | each destination = nm] ifNone: []
! !

!NmWorldMap methodsFor: 'accessing name' stamp: 'mu 12/25/2004 01:04'!
worldNamesExcluding: point 
	^ (self entries
		reject: [:each | each point = point])
		collect: [:each | each name]! !

!NmWorldMap methodsFor: 'accessing name' stamp: 'mu 1/24/2005 02:25'!
worldNamesWithoutLocal
	^self allWorldNames reject: [:each | each = self localName]! !


!NmWorldMap methodsFor: 'actions' stamp: 'mu 12/21/2004 01:12'!
at: uuidStr
	^self findById: uuidStr! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 8/3/2005 09:57'!
at: uuidStr ifAbsent: aBlock
	
	^map at: uuidStr asString ifAbsent: aBlock! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 1/24/2005 00:54'!
at: uuidStr put: aWorldMapEntry 
	map at: uuidStr asString put: aWorldMapEntry.
	self changed! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 5/11/2005 00:08'!
clingTogetherAloneEntries
	| aloneEnts |
	[self lock.
	aloneEnts _ self selectAloneEntries.
	aloneEnts
		do: [:each | self adjustEntryToNearest: each].
	self hasChanged
		ifTrue: [self incrementVersion.
			self storeNamed: self mapName useServer: false]]
		ensure: [self unlock]! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 12/21/2004 01:04'!
entries
	^map values
! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 1/24/2005 23:14'!
entriesWithout: worldMapEntry
	"NmWorldMap default entriesWithout: NmWorldMap default localEntry"
	| keys |
	keys _ map keys removeAllSuchThat: [:each | each = worldMapEntry id].
	^keys collect: [:k | self at: k ]
! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 1/25/2005 00:05'!
entries: aCollectionOfWorldMapEntry
	self initWithEntries: aCollectionOfWorldMapEntry! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 1/24/2005 01:46'!
findById: uuidStr
	^map at: uuidStr asString  ifAbsent:[]! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 1/24/2005 02:16'!
forceRegister: aWorldMapEntry 
	self at: aWorldMapEntry id put: aWorldMapEntry.
	^ aWorldMapEntry! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 12/21/2004 01:13'!
includesKey: uuidStr
	^map includesKey: uuidStr asString

! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 5/6/2005 02:31'!
incrementVersion
	version _ version + 1! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 5/2/2005 01:56'!
keys
	^map keys
! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 2/3/2005 22:34'!
lock
	^self lockWith: UUID new asString! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 2/3/2005 22:23'!
lockWith: uuidStr 
	self isLocked
		ifTrue: [NmLockFailed signal: 'Lock from wrong client: ' , uuidStr asString.
			^ nil].
	^ locker _ uuidStr asString! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 8/11/2005 11:16'!
registerDodgeIfConflict: aWorldMapEntry 
	| withoutMeEntries origPoint points sameIps sameIpAndPorts |
	withoutMeEntries := self entriesWithout: aWorldMapEntry.

	origPoint := aWorldMapEntry point.
	points := withoutMeEntries collect: [:each | each point].
	(points includes: origPoint)
		ifTrue: [aWorldMapEntry
				point: (self emptyPointConsidering: points)].

	sameIps := withoutMeEntries select: [:each | each ip = aWorldMapEntry ip].
	sameIpAndPorts := sameIps select: [:each | each port = aWorldMapEntry port].
	sameIpAndPorts ifNotEmpty: [aWorldMapEntry
				port: (self emptyPortConsidering: (sameIps collect: [:each | each port asInteger]))].

	self at: aWorldMapEntry id put: aWorldMapEntry.
	^ aWorldMapEntry! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 4/30/2005 23:48'!
removeKey: uuidStr
	map removeKey: uuidStr asString.
	self changed! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 1/25/2005 00:14'!
removeKey: uuidStr ifAbsent: aBlock
	map removeKey: uuidStr asString ifAbsent: aBlock.
	self changed! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 4/30/2005 23:51'!
removeNotUpdatedFor: seconds 
	| currentTime |
	currentTime _ DateAndTime totalSeconds.
	self map copy
		do: [:each | (currentTime - each lastChangedTime) abs > seconds
				ifTrue: [self remove: each ifAbsent:[]]]! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 1/22/2005 03:00'!
remove: aWorldMapEntry
	map removeKey: aWorldMapEntry id asString ifAbsent:[^nil].
	self changed! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 5/2/2005 01:49'!
remove: aWorldMapEntry ifAbsent: block
	map removeKey: aWorldMapEntry id asString ifAbsent:[^block value].
	self changed! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 5/10/2005 03:02'!
unlock
	self unlockWith: locker! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 2/4/2005 00:28'!
unlockWith: uuidStr 
	self isLocked ifFalse: [^nil].
	uuidStr = locker
		ifTrue: [locker _ nil]
		ifFalse: [NmUnlockFailed signal: 'Unlock from wrong client: ' , uuidStr asString.
			^ nil]! !


!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 8/10/2005 10:00'!
basicLoad
	"NmWorldMap default basicLoad"
	| mapString |
	self isLocked
		ifTrue: [^ self].
	NmServerManager isMapServerOnlyImage
		ifTrue: [^ self].
	mapString _ self callLoadNamed: self mapName.
	self fromCsvString: mapString.
	self localEntry isNil
		ifTrue: [oldLocalEntry
				ifNotNilDo: [:ent | 
					self forceRegister: ent;
						 unchanged.
					self updateWithLocalEntry]]! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 5/10/2005 18:00'!
forget
	self forgetNamed: self mapName useServer: false 
	! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 5/10/2005 18:02'!
forgetNamed: mapNameStr
	self forgetNamed: self mapName 
	! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 5/10/2005 18:00'!
forgetNamed: mapNameStr useServer: useExternalAdminServer 
	self isLocked
		ifTrue: [^ self].
	useExternalAdminServer
		ifTrue: ["self callForgetNamed: mapNameStr"
			#TBD]
		ifFalse: [NmWorldInfoReadWriter deleteCsvFile: mapNameStr]! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 6/13/2005 23:43'!
listLoadableMapNames
	^ self callListLoadableMapNames! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 3/9/2005 00:27'!
load
	[self basicLoad]
		on: SoapImplError, RmtNetworkError
		do: [:ex | 
			self triggerEvent: #worldMapLoadFailed.
			^NmTranscript crShow: ex description].
	self triggerEvent: #worldMapLoaded.
	NmTranscript crShow: '## NmWorldMap was loaded: ' , self map printString.! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 8/11/2005 13:17'!
store
	"NmWorldMap default store"
	NmTranscript crShow: #'STORE WorldMap: ', Time now asString.
	self storeNamed: self mapName useServer: NmServerManager isMapServerOnlyImage not! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 6/13/2005 23:43'!
storeNamed: mapNameStr 
	^ self storeNamed: mapNameStr useServer: true! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 7/5/2005 21:00'!
storeNamed: mapNameStr useServer: useExternalServer
	self isLocked ifTrue: [ ^self].
	useExternalServer
		ifTrue: [self callStoreNamed: mapNameStr]
		ifFalse: [NmWorldInfoReadWriter putCsvString: self csvString toFile: mapNameStr].
	self allUnchanged.
	self triggerEvent: #worldMapStored.! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 8/11/2005 13:16'!
update
	"NmWorldMap default update"
	NmTranscript crShow: #'UPDATE WorldMap Entry: ', Time now asString.
	self updateWithVersion.
	self updateWithLocalEntry.
	! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 8/10/2005 09:47'!
updateWithLocalEntry
	"NmWorldMap default updateWithLocalEntry"
	| oldMap csvStr |
	self isLocked
		ifTrue: [^ self].
	self localEntry
		ifNil: [self resetLocal].
	oldMap := self map.
	csvStr := self callUpdateLocalEntry.
	self triggerEvent: #worldMapStored.
	csvStr
		ifNotNil: [self fromCsvString: csvStr].
	oldMap = self map
		ifFalse: [self triggerEvent: #localEntryUpdated]! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 6/13/2005 23:44'!
updateWithVersion
	"NmWorldMap default updateWithVersion"
	| currentVersion |
	self isLocked
		ifTrue: [^ self].
	currentVersion _ self callGetVersion.
	(currentVersion notNil
			and: [currentVersion > self version])
		ifTrue: [self load]! !


!NmWorldMap methodsFor: 'accessing destination' stamp: 'mu 5/10/2005 19:10'!
bottomDestination
	"NmWorldMap default bottomDestination"
	^self atPoint:  self localPoint + (0@-1) ifAbsent: []
		! !

!NmWorldMap methodsFor: 'accessing destination' stamp: 'mu 5/10/2005 19:10'!
leftDestination
	"NmWorldMap default leftDestination"
	^self atPoint: self localPoint + (-1@0) ifAbsent: []
		! !

!NmWorldMap methodsFor: 'accessing destination' stamp: 'mu 5/10/2005 19:10'!
rightDestination
	"NmWorldMap default rightDestination"
	^self atPoint: self localPoint + (1@0) ifAbsent: []
		! !

!NmWorldMap methodsFor: 'accessing destination' stamp: 'mu 5/10/2005 19:10'!
topDestination
	"NmWorldMap default topDestination"
	^self atPoint:  self localPoint + (0@1) ifAbsent: []
		! !


!NmWorldMap methodsFor: 'obsolete' stamp: 'mu 12/25/2004 03:13'!
bottomOf: destinationName 
	"NmWorldMap bottomOf: 'nm://smalltalk:37458/' asUrl"
	| point destinationPoint entry |
	point _ self pointOf: destinationName.
	point isNil
		ifTrue: [^ nil].
	destinationPoint _ Point x: point x y: point y - 1.
	entry _ self atPoint: destinationPoint.
	^ entry
		ifNotNilDo: [:ent | 
			| nm | 
			nm _ entry name.
			nm
				ifNotNilDo: [:n | n asUrl isNmUrl
						ifTrue: [n asUrl]
						ifFalse: [n]]]! !

!NmWorldMap methodsFor: 'obsolete' stamp: 'mu 12/25/2004 03:13'!
leftOf: destinationName 
	"NmWorldMap leftOf: 'nm://smalltalk:37458/' asUrl"
	| point destinationPoint entry |
	point _ self pointOf: destinationName.
	point isNil
		ifTrue: [^ nil].
	destinationPoint _ Point x: point x - 1 y: point y.
	entry _ self atPoint: destinationPoint.
	^ entry
		ifNotNilDo: [:ent | 
			| nm | 
			nm _ entry name.
			nm
				ifNotNilDo: [:n | n asUrl isNmUrl
						ifTrue: [n asUrl]
						ifFalse: [n]]]! !

!NmWorldMap methodsFor: 'obsolete' stamp: 'mu 12/25/2004 03:14'!
rightOf: destinationName 
	"NmWorldMap rightOf: 'nm://smalltalk:37458/' asUrl"
	| point destinationPoint entry |
	point _ self pointOf: destinationName.
	point isNil
		ifTrue: [^ nil].
	destinationPoint _ Point x: point x + 1 y: point y.
	entry _ self atPoint: destinationPoint.
	^ entry
		ifNotNilDo: [:ent | 
			| nm | 
			nm _ entry name.
			nm
				ifNotNilDo: [:n | n asUrl isNmUrl
						ifTrue: [n asUrl]
						ifFalse: [n]]]! !

!NmWorldMap methodsFor: 'obsolete' stamp: 'mu 12/25/2004 03:13'!
topOf: destinationName 
	"NmWorldMap topOf: 'nm://smalltalk:37458/' asUrl"
	| point destinationPoint entry |
	point _ self pointOf: destinationName.
	point isNil
		ifTrue: [^ nil].
	destinationPoint _ Point x: point x y: point y + 1.
	entry _ self atPoint: destinationPoint.
	^ entry
		ifNotNilDo: [:ent | 
			| nm | 
			nm _ entry name.
			nm
				ifNotNilDo: [:n | n asUrl isNmUrl
						ifTrue: [n asUrl]
						ifFalse: [n]]]! !


!NmWorldMap methodsFor: 'writing' stamp: 'mu 5/7/2005 00:52'!
csvString
	| mapDictionary stream |
	mapDictionary _ self map.
	mapDictionary isNil ifTrue: [^''].
	stream _ WriteStream on: String new.
	self headerCsvOn: stream.
	mapDictionary
		valuesDo: [ :value | 
			stream nextPutAll: value asString.
			stream nextPut: Character cr].
	^ stream contents! !

!NmWorldMap methodsFor: 'writing' stamp: 'mu 5/7/2005 09:34'!
headerCsvOn: aStream 
	aStream nextPutAll: self mapName asString;
		 nextPut: $,;
		 nextPutAll: self version asString;
		 nextPut: Character cr! !


!NmWorldMap methodsFor: 'reading' stamp: 'mu 7/5/2005 20:46'!
fromCsvString: aString 
	aString isEmptyOrNil
		ifTrue: [^ self].
	self readFrom: (ReadStream on: aString).
	! !

!NmWorldMap methodsFor: 'reading' stamp: 'mu 7/5/2005 20:50'!
readFrom: aStream
	| stream entries |
	stream _ aStream.
	self readHeaderCsvFrom: stream.
	entries _ OrderedCollection new.
	[stream atEnd]
		whileFalse: [| line | 
			line _ stream nextLine.
			(line includes: $,)
				ifTrue: [| ent | 
					ent _ NmWorldMapEntry fromCsvString: line. 
					entries add: ent]].
	self entries: entries.
	
	! !

!NmWorldMap methodsFor: 'reading' stamp: 'mu 5/7/2005 09:57'!
readHeaderCsvFrom: aStream 
	| line lineStream |
	line _ aStream nextLine.
	lineStream _ line readStream.
	self
		mapName: (lineStream upTo: $,).
	self
		version: (lineStream upTo: $,)! !


!NmWorldMap methodsFor: 'initialize-release' stamp: 'mu 5/7/2005 09:32'!
initialize
	"NmWorldMap default initialize"
	self initMap.
	mapName _ nil.
	version _ 0.
	! !

!NmWorldMap methodsFor: 'initialize-release' stamp: 'mu 4/3/2005 23:10'!
initMap
	map _ Dictionary new.
	self changed! !

!NmWorldMap methodsFor: 'initialize-release' stamp: 'mu 1/25/2005 00:04'!
initWithEntries: aCollectionOfWorldMapEntry
	self initMap.
	aCollectionOfWorldMapEntry do: [:each | self at: each id put: each]
! !


!NmWorldMap methodsFor: 'testing' stamp: 'mu 5/2/2005 01:54'!
isEmpty
	^self map isEmpty! !

!NmWorldMap methodsFor: 'testing' stamp: 'mu 4/10/2005 00:13'!
isLocal
	^self = NmWorldMap default! !

!NmWorldMap methodsFor: 'testing' stamp: 'mu 2/3/2005 22:08'!
isLocked
	^locker notNil! !


!NmWorldMap methodsFor: 'accessing'!
map
	^ map! !

!NmWorldMap methodsFor: 'accessing' stamp: 'mu 4/3/2005 23:43'!
mapName
	mapName
		ifNil: [mapName _ self class defaultMapName].
	^ mapName! !

!NmWorldMap methodsFor: 'accessing' stamp: 'mu 5/10/2005 17:24'!
mapName: aString
	mapName _ aString.
	self changed: #mapName.
	! !

!NmWorldMap methodsFor: 'accessing' stamp: 'mu 1/22/2005 01:58'!
map: aDictionary
	map _ aDictionary.
	self changed
	
! !

!NmWorldMap methodsFor: 'accessing' stamp: 'mu 5/7/2005 10:04'!
version
	version ifNil: [version _ 0].
	^version! !

!NmWorldMap methodsFor: 'accessing' stamp: 'mu 5/10/2005 17:24'!
version: anInteger
	version _ anInteger asInteger.
	self changed: #version.! !


!NmWorldMap methodsFor: 'printing' stamp: 'mu 4/10/2005 00:17'!
printOn: aStream 
	| name |
	super printOn: aStream.
	name _ self mapName.
	name
		ifNotNilDo: [:n | aStream space; nextPutAll: ' ('; nextPutAll: n; nextPutAll: ')']! !


!NmWorldMap methodsFor: 'updating' stamp: 'mu 8/10/2005 09:13'!
registerLocalEntry: uuidStr 
	| newLocal |
	newLocal := NmWorldMapEntry newWithId: uuidStr.
	oldLocalEntry isNil
		ifFalse: [newLocal inherit: oldLocalEntry.
			oldLocalEntry becomeForward: newLocal].
	self forceRegister: newLocal.
	self updateWithLocalEntry.
	"self triggerEvent: #worldMapLoaded.
	self store."
	^ newLocal! !

!NmWorldMap methodsFor: 'updating' stamp: 'mu 6/15/2005 19:24'!
removeLocalEntry: uuidStr 
	oldLocalEntry _ self
				at: uuidStr
				ifAbsent: [].
	map
		removeKey: uuidStr
		ifAbsent: [].
	self callRemoveEntry: uuidStr
	
! !


!NmWorldMap methodsFor: 'comparing' stamp: 'mu 4/3/2005 23:40'!
= aNmWorldMap 
	(aNmWorldMap isKindOf: self class)
		ifFalse: [^ false].
	self map = aNmWorldMap map
		ifFalse: [^ false].
	self mapName = aNmWorldMap mapName
		ifFalse: [^ false].
	^ true! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmWorldMap class
	instanceVariableNames: 'default'!

!NmWorldMap class methodsFor: 'instance creation' stamp: 'mu 12/28/2004 00:06'!
default
	default
		ifNil: [default _ self basicNew initialize].
	^ default! !

!NmWorldMap class methodsFor: 'instance creation' stamp: 'mu 4/29/2005 00:26'!
fromCsvString: aString 
	| inst |
	inst _ self new.
	inst fromCsvString: aString.
	^ inst! !

!NmWorldMap class methodsFor: 'instance creation' stamp: 'mu 1/21/2005 02:20'!
new
	^self basicNew initialize! !


!NmWorldMap class methodsFor: 'constants' stamp: 'mu 4/28/2005 17:44'!
defaultMapName
	^ 'WorldMap' copy.! !


!NmWorldMap class methodsFor: 'class initialization' stamp: 'mu 5/12/2005 19:14'!
initialize
	"NmWorldMap initialize"
	default _ nil.
	NmImageId addDependent: self.
	! !

!NmWorldMap class methodsFor: 'class initialization' stamp: 'mu 12/28/2004 00:06'!
obsolete
	default _ nil.
	NmImageId removeDependent: self.
	! !


!NmWorldMap class methodsFor: 'utilities' stamp: 'mu 7/13/2005 19:00'!
localEntry
	^self default localEntry! !


!NmWorldMap class methodsFor: 'updating' stamp: 'mu 6/15/2005 19:24'!
update: aspect with: value 
	NmServerManager isMapServerOnlyImage ifTrue: [^self].
	aspect == #imageIdNuked
		ifTrue: [self default removeLocalEntry: value ].
	aspect == #imageIdNew
		ifTrue: [self default registerLocalEntry: value ]! !


Model subclass: #NmWorldMapEntry
	instanceVariableNames: 'id point name ip port hasChanged lastChangedTime deferredUpdate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-WorldMap'!

!NmWorldMapEntry methodsFor: 'converting' stamp: 'mu 5/10/2005 20:30'!
asDestination
	^self! !


!NmWorldMapEntry methodsFor: 'printing' stamp: 'mu 1/22/2005 01:01'!
asString
	^self csvString! !

!NmWorldMapEntry methodsFor: 'printing' stamp: 'mu 1/22/2005 01:01'!
csvString
	^String streamContents: [:str | self printCsvOn: str]! !

!NmWorldMapEntry methodsFor: 'printing' stamp: 'mu 2/3/2005 23:38'!
descriptionString
	^String streamContents: [:str | self printCsvOn: str]! !

!NmWorldMapEntry methodsFor: 'printing' stamp: 'mu 12/22/2004 01:54'!
printCsvOn: aStream 
	aStream nextPutAll: self id asString;
		 nextPutAll: ', ';
		 nextPutAll: self name;
		 nextPutAll: ', ';
		 nextPutAll: self point asString;
		 nextPutAll: ', ';
		 nextPutAll: self ip;
		 nextPutAll: ', ';
		 nextPutAll: self port! !

!NmWorldMapEntry methodsFor: 'printing' stamp: 'mu 12/26/2004 01:47'!
printOn: aStream 
	self isLocal
		ifTrue: [aStream nextPutAll: 'LOCAL:'].
	aStream nextPutAll: '(id: ';
		 nextPutAll: self id asString;
		 nextPutAll: ' name: ';
		 nextPutAll: self name;
		 nextPutAll: ' point: ';
		 nextPutAll: self point asString;
		 nextPutAll: ' ip: ';
		 nextPutAll: self ip;
		 nextPutAll: ' port: ';
		 nextPutAll: self port;
		 nextPutAll: ' )'! !


!NmWorldMapEntry methodsFor: 'changing' stamp: 'mu 8/11/2005 10:57'!
changed
	hasChanged := true.
	self resetLastChangedTime.
	super changed.! !

!NmWorldMapEntry methodsFor: 'changing' stamp: 'mu 1/21/2005 23:17'!
hasChanged
	hasChanged ifNil: [hasChanged _ false].
	^hasChanged! !

!NmWorldMapEntry methodsFor: 'changing' stamp: 'mu 8/11/2005 10:56'!
resetLastChangedTime
	lastChangedTime := DateAndTime totalSeconds.
	! !

!NmWorldMapEntry methodsFor: 'changing' stamp: 'mu 3/2/2005 01:22'!
unchanged
	hasChanged _ false.
	super changed.! !


!NmWorldMapEntry methodsFor: 'actions-updating' stamp: 'mu 8/7/2005 10:36'!
asDeferredUpdate
	^self copy beDeferredUpdate ! !

!NmWorldMapEntry methodsFor: 'actions-updating' stamp: 'mu 8/7/2005 19:45'!
beDeferredLocal
	id := NmImageId current asString.
	self beDeferredUpdate! !

!NmWorldMapEntry methodsFor: 'actions-updating' stamp: 'mu 8/7/2005 11:01'!
beDeferredUpdate
	point := ip := port := hasChanged := lastChangedTime := nil.
	self deferredUpdate: true! !


!NmWorldMapEntry methodsFor: 'actions' stamp: 'mu 12/27/2004 01:37'!
destination
	^ self name isEmptyOrNil
		ifTrue: [self ipAndPort]
		ifFalse: [self name]! !

!NmWorldMapEntry methodsFor: 'actions' stamp: 'mu 12/25/2004 23:51'!
inherit: aWorldMapEntry
	self name: aWorldMapEntry name.
	self point: aWorldMapEntry point.
	self ip: aWorldMapEntry ip.
	self port: aWorldMapEntry port.
	! !

!NmWorldMapEntry methodsFor: 'actions' stamp: 'mu 12/22/2004 00:58'!
ipAndPort
	^self ip, ':', self port! !

!NmWorldMapEntry methodsFor: 'actions' stamp: 'mu 5/10/2005 19:17'!
ipAndPortArray
	^{self ip. self port asInteger}! !

!NmWorldMapEntry methodsFor: 'actions' stamp: 'mu 8/10/2005 09:35'!
resetLocalPort: newPortNumber
	| newPort |
	self isLocal
		ifFalse: [^ self].
	newPort _ newPortNumber asString withBlanksTrimmed.
	port = newPort ifTrue: [^self].
	port := newPort.
	self name: (self destination copyLastPortPartTo: port).

	NmWorldMap default updateWithLocalEntry
	! !


!NmWorldMapEntry methodsFor: 'comparing' stamp: 'mu 12/21/2004 00:57'!
hash
	^self id hash! !

!NmWorldMapEntry methodsFor: 'comparing' stamp: 'mu 1/24/2005 01:12'!
sameAs: aWorldMapEntry
	^self id = aWorldMapEntry id! !

!NmWorldMapEntry methodsFor: 'comparing' stamp: 'mu 1/24/2005 01:13'!
= aWorldMapEntry
	^self csvString = aWorldMapEntry csvString! !


!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/7/2005 10:09'!
deferredLocal
	^self deferredUpdate and: [id isNil]! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/7/2005 09:54'!
deferredUpdate
	deferredUpdate ifNil: [deferredUpdate := false].
	^deferredUpdate! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/7/2005 09:56'!
deferredUpdate: aBoolean
	deferredUpdate _ aBoolean == true! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/7/2005 11:56'!
id
	self deferredLocal ifTrue: [^NmImageId current asString].
	id ifNil:[id := UUID new asString].
	^id! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 5/14/2005 00:21'!
id: uuidStr
	| oldId |
	oldId _ id.
	id _ uuidStr asString withBlanksTrimmed.
	oldId = id ifFalse: [self changed]
	! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/7/2005 10:44'!
ip
	self deferredUpdate  ifTrue: [self entryFromMap ifNotNilDo:[:ent | ^ent ip]].
	self isLocal ifTrue: [^NmBaseUtil localAddress].
	ip ifNil:[ip := NmBaseUtil localAddress].
	^ip! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 7/6/2005 02:40'!
ip: aString 
	| oldIp |
	oldIp _ ip.
	ip _ aString asString withBlanksTrimmed.
	self isLocal
		ifTrue: [| locAdd | 
			locAdd _ NmBaseUtil localAddress.
			ip = locAdd
				ifFalse: [ip _ locAdd]].
	oldIp = ip ifFalse: [self changed]
	! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 2/1/2005 23:55'!
lastChangedTime
	lastChangedTime ifNil: [lastChangedTime _ 0].
	^lastChangedTime! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/7/2005 10:42'!
name
	self deferredUpdate ifTrue: [self entryFromMap ifNotNilDo:[:ent | ^ent name]].
	name
		ifNil: [name := ''].
	(self isLocal
			and: [name isNmUrlString])
		ifTrue: [^ NmUrl local asString].
	^ name! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 7/6/2005 20:43'!
name: aString 
	| oldName |
	oldName _ name.
	name _ aString asString withBlanksTrimmed.
	(oldName isNil and: [name isEmpty]) ifTrue: [^ self name].
	name isNmUrlString
		ifTrue: [| url | 
			self isLocal
				ifTrue: [url _ NmUrl local.
					name _ url asString]
				ifFalse: [url _ name asNmUrl].
			self ip: url resolvedIp.
			self port: url port].
	oldName = name
		ifFalse: [self changed]! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/7/2005 10:44'!
point
	self deferredUpdate  ifTrue: [self entryFromMap ifNotNilDo:[:ent | ^ent point]].
	point ifNil:[point := 0@0].
	^point! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/11/2005 13:17'!
point: aPoint
	| oldPoint po  |
	oldPoint _ point.
	po _  aPoint isString ifTrue: [Point readFrom: aPoint] ifFalse:[aPoint].
	point _ po.
	oldPoint = point ifFalse: [self changed].
	! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/7/2005 10:44'!
port
	self deferredUpdate  ifTrue: [self entryFromMap ifNotNilDo:[:ent | ^ent port]].
	self isLocal ifTrue: [^NmBaseSettings warpPort asString].
	port ifNil:[port := NmBaseSettings warpPort asString].
	^port! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 1/21/2005 23:52'!
port: aString
	| oldPort |
	oldPort _ port. 
	port _ aString asString withBlanksTrimmed.
	self isLocal
		ifTrue: [NmBaseSettings warpPort: port asInteger].
	oldPort = port ifFalse: [self changed]! !


!NmWorldMapEntry methodsFor: 'testing' stamp: 'mu 12/28/2004 00:19'!
isLocal
	^self id = NmWorldMap default localId! !


!NmWorldMapEntry methodsFor: 'private' stamp: 'mu 8/7/2005 09:49'!
entryFromMap
	^ NmWorldMap default
		at: self id
		ifAbsent: []! !


!NmWorldMapEntry methodsFor: 'reading' stamp: 'mu 7/5/2005 20:55'!
readCsvFrom: aStream
	self id: (aStream upTo: $,).
	self name: (aStream upTo: $,).
	self point: (aStream upTo: $,).
	self ip: (aStream upTo: $,).
	self port:  (aStream upToEnd).
	
	! !


!NmWorldMapEntry methodsFor: 'objects from disk' stamp: 'mu 7/13/2005 18:48'!
storeDataOn: aDataStream 
	self myDependents: nil.
	hasChanged _ lastChangedTime _ nil.
	super storeDataOn: aDataStream! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmWorldMapEntry class
	instanceVariableNames: ''!

!NmWorldMapEntry class methodsFor: 'instance creation' stamp: 'mu 7/5/2005 19:24'!
fromCsvString: aString
	^self readCsvFrom: aString readStream! !

!NmWorldMapEntry class methodsFor: 'instance creation' stamp: 'mu 6/3/2005 19:15'!
id: uuid point: point name: nm 
	^ (self
		id: uuid
		point: point
		name: nm
		ip: NmBaseUtil localAddress
		port: NmBaseSettings warpPort) unchanged! !

!NmWorldMapEntry class methodsFor: 'instance creation' stamp: 'mu 1/21/2005 23:35'!
id: uuid point: point name: nm ip: ip port: port 
	^ (self newWithId: uuid) point: point;
		 name: nm;
		 ip: ip;
		 port: port;
		 unchanged! !

!NmWorldMapEntry class methodsFor: 'instance creation' stamp: 'mu 5/13/2005 02:16'!
ip: ip port: port 
	^self id: UUID new point: 0@0 name: '' ip: ip port: port ! !

!NmWorldMapEntry class methodsFor: 'instance creation' stamp: 'mu 12/24/2004 01:48'!
newWithId: uuidStr
	"NmWorldMapEntry newWithId"
	| inst |
	inst _ NmWorldMapEntry new.
	inst id: uuidStr.
	^inst! !

!NmWorldMapEntry class methodsFor: 'instance creation' stamp: 'mu 6/3/2005 19:15'!
point: point name: nm 
	^ self
		id: UUID new
		point: point
		name: nm
		ip: NmBaseUtil localAddress
		port: NmBaseSettings warpPort! !

!NmWorldMapEntry class methodsFor: 'instance creation' stamp: 'mu 12/24/2004 03:06'!
point: point name: nm ip: ip port: port 
	^self id: UUID new point: point name: nm ip: ip port: port ! !

!NmWorldMapEntry class methodsFor: 'instance creation' stamp: 'mu 1/21/2005 23:35'!
readCsvFrom: aStream 
	^ self basicNew readCsvFrom: aStream;
		 unchanged! !

NmPointAllocator initialize!
NmWorldMap initialize!